{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: Form for adding new entry
//******************************************************
//******************************************************

unit FNewFld;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, INIUtil, FSaver, Spin, INISec, INIEnt;

type
  TfrmNewField = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    PanelForSBExt1: TAutoAlignPanel;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label1: TLabel;
    EFieldName: TEdit;
    EDisplayLabel: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    ECName: TEdit;
    CMBType: TComboBox;
    GroupBox2: TGroupBox;
    CBCalculated: TCheckBox;
    CBVisible: TCheckBox;
    CBReadOnly: TCheckBox;
    FormSaver: TFormSaver;
    Label5: TLabel;
    Label6: TLabel;
    EDefValue: TEdit;
    CMBCaptionStyle: TComboBox;
    CBShowInGrid: TCheckBox;
    Label7: TLabel;
    EDisplayWidth: TSpinEdit;
    Label9: TLabel;
    EPL: TSpinEdit;
    Label8: TLabel;
    EHint: TEdit;
    INIDatabase: TINIDatabase;
    secTfrmNewField: TINISection;
    secTfrmNewFieldEDefValue: TINIEntryString;
    secTfrmNewFieldEHint: TINIEntryString;
    secTfrmNewFieldCBCalculated: TINIEntryBoolean;
    secTfrmNewFieldCBVisible: TINIEntryBoolean;
    secTfrmNewFieldCBReadOnly: TINIEntryBoolean;
    secTfrmNewFieldCBShowInGrid: TINIEntryBoolean;
    secTfrmNewFieldEDisplayWidth: TINIEntryInteger;
    secTfrmNewFieldEPL: TINIEntryInteger;
    BBOk: TBitBtn;
    BBCancel: TBitBtn;
    BBHelp: TBitBtn;
    secTfrmNewFieldCMBCaptionStyle: TINIEntryString;
    BBReset: TBitBtn;
    procedure EDisplayLabelKeyPress(Sender: TObject; var Key: Char);
    procedure EFieldNameChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CMBTypeKeyPress(Sender: TObject; var Key: Char);
    procedure BBHelpClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BBOkClick(Sender: TObject);
    procedure BBResetClick(Sender: TObject);
  private
  	FPrefix,FOldFieldName:string;

		procedure FillEntryClasses;

  public
  	function GetEntryData(const Prefix,FieldName:string;Level,EntryID:Integer):word;
  end;

var
  frmNewField: TfrmNewField;

implementation

uses INIMis;

{$R *.DFM}

procedure TfrmNewField.EDisplayLabelKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key=#27 then begin
  	Key:=#0;

    ModalResult:=mrCancel;
  end;
end;

function TfrmNewField.GetEntryData(const Prefix,FieldName:string;Level,EntryID:Integer):word;
begin
	FPrefix:=Prefix;
	FOldFieldName:=FieldName;

  EFieldName.Text:=FieldName;
	EDisplayLabel.Text:=EFieldName.Text;
	ECName.Text:=FPrefix+MakeIdent(EFieldName.Text);
  EPL.Value:=Level;

  CMBType.ItemIndex:=EntryID;
  CMBCaptionStyle.ItemIndex:=1;

  Result:=ShowModal;
end;

procedure TfrmNewField.EFieldNameChange(Sender: TObject);
begin
	if EDisplayLabel.Text=FOldFieldName then begin
  	EDisplayLabel.Text:=EFieldName.Text;

    if ECName.Text=FPrefix+MakeIdent(FOldFieldName) then begin
    	ECName.Text:=FPrefix+MakeIdent(EFieldName.Text);
    end;
  end;

  FOldFieldName:=EFieldName.Text;
end;

procedure TfrmNewField.FormCreate(Sender: TObject);
begin
	FillEntryClasses;
end;

procedure TfrmNewField.FillEntryClasses;
var i:Integer;
begin
	CMBType.Items.Clear;

	for i:=0 to GetEntryClassesCount-1 do begin
  	CMBType.Items.Add(GetEntryClassDescription(i));
  end;

  CMBType.DropDownCount:=Min(16,CMBType.Items.Count);
end;

procedure TfrmNewField.CMBTypeKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#27 then begin
  	Key:=#0;

    ModalResult:=mrCancel;
  end;
end;

procedure TfrmNewField.BBHelpClick(Sender: TObject);
begin
	Application.HelpJump('NewEntry');
end;

procedure TfrmNewField.FormShow(Sender: TObject);
begin
	INIDatabase.Read;

  secTfrmNewField.Syncronize(sdToControl);
end;

procedure TfrmNewField.BBOkClick(Sender: TObject);
begin
   secTfrmNewField.Syncronize(sdToEntry);

	INIDatabase.Write;
end;

procedure TfrmNewField.BBResetClick(Sender: TObject);
begin
	INIDatabase.Reset;

  secTfrmNewField.Syncronize(sdToControl);
end;

end.
