{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: Form for selecting registry node. Uses TDBTreeView.
//******************************************************
//******************************************************

unit FRegNode;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, INIUtil, ExtCtrls, FSaver,INISec,INIEnt,
  INITree,INIFile;

type
  TfrmSelectRegistryNode = class(TForm)
    Panel2: TPanel;
    pnlButtons: TAutoAlignPanel;
    BBOk: TBitBtn;
    BBCancel: TBitBtn;
    Panel1: TPanel;
    FormSaver: TFormSaver;
    BBHelp: TBitBtn;
    TV: TDBTreeView;
    listNode: TSimpleListDistributor;
    imgList: TImageList;
    listKeys: TSimpleListDistributor;
    procedure FormResize(Sender: TObject);
    procedure BBHelpClick(Sender: TObject);
    procedure listNodeCustomizeList(Sender: TObject; Node: TTreeNode;
      List: TStringList);
    procedure FormShow(Sender: TObject);
    procedure TVChange(Sender: TObject; Node: TTreeNode);
    procedure listKeysCustomizeList(Sender: TObject; Node: TTreeNode;
      List: TStringList);
  private
  	FComputerName,FInitPath:string;

  protected
		procedure WMGetMinMaxInfo(var Msg:TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

  public
  	function GetNode(const ComputerName,InitPath:string):string;
  end;

var
  frmSelectRegistryNode: TfrmSelectRegistryNode;

implementation

uses INIMis;

{$R *.DFM}

function TfrmSelectRegistryNode.GetNode(const ComputerName,InitPath:string):string;
begin
	Result:='';

  FComputerName:=ComputerName;
  FInitPath:=InitPath;

	if (ShowModal=mrOK) and (TV.Selected<>nil) then begin
  	if TV.Selected.Parent=nil then
	  	Result:=GetNodeID(TV.Selected)
    else
	  	Result:=MergePaths(TV.SelectionByName[TV.Selected,listKeys.ParamName],GetNodeID(TV.Selected));
  end;
end;

procedure TfrmSelectRegistryNode.WMGetMinMaxInfo(var Msg:TWMGetMinMaxInfo);
begin
	inherited;

  with Msg.MinMaxInfo^.ptMinTrackSize do begin
  	x:=200;
    y:=120;
  end;
end;

procedure TfrmSelectRegistryNode.FormResize(Sender: TObject);
begin
  pnlButtons.Width:=Min(250,Self.ClientWidth);
end;

procedure TfrmSelectRegistryNode.BBHelpClick(Sender: TObject);
begin
	Application.HelpJump('SelectRegistryNode');
end;

procedure TfrmSelectRegistryNode.listNodeCustomizeList(Sender: TObject;Node: TTreeNode; List: TStringList);
var lList:TStringList;

  procedure DoMain;
	var RegistryStream:TINIStreamRegistry;
  		i:Integer;
  begin
		RegistryStream:=TINIStreamRegistry.CreateStream(FComputerName,TV.SelectionByName[Node,listKeys.ParamName]);

    try
    	if GetNodeLevel(Node)=1 then begin
	      RegistryStream.ReadSections('',lList);

				for i:=0 to lList.Count-1 do begin
          List.AddObject(lList[i],TNodeObject.CreateImage(lList[i],0));
        end;
      end else begin
	      RegistryStream.ReadSections(GetNodeID(Node),lList);

        for i:=0 to lList.Count-1 do begin
          List.AddObject(lList[i],TNodeObject.CreateImage(MergePaths(GetNodeID(Node),lList[i]),0));
        end;
      end;

      finally
        RegistryStream.Free;
    end;
  end;

begin
	lList:=TStringList.Create;

  try
  	DoMain;

  	finally
    	lList.Free;
  end;
end;

procedure TfrmSelectRegistryNode.FormShow(Sender: TObject);
begin
	TV.Init(False);

  if FInitPath<>'' then TV.GoToPath(FInitPath);
end;

procedure TfrmSelectRegistryNode.TVChange(Sender: TObject;
  Node: TTreeNode);
begin
	if Node<>nil then Node.SelectedIndex:=1;
end;

procedure TfrmSelectRegistryNode.listKeysCustomizeList(Sender: TObject;  Node: TTreeNode; List: TStringList);
var i:Integer;
begin
	if FComputerName<>'' then begin
 		List.AddObject(CHKEYDescriptions[hkLOCAL_MACHINE],TNodeObject.CreateImage(CHKEYDescriptions[hkLOCAL_MACHINE],0));
 		List.AddObject(CHKEYDescriptions[hkUSERS],TNodeObject.CreateImage(CHKEYDescriptions[hkUSERS],0));
  end else begin
		for i:=0 to Integer(High(THKEY))-1 do begin
  		List.AddObject(CHKEYDescriptions[THKEY(i)],TNodeObject.CreateImage(CHKEYDescriptions[THKEY(i)],0));
	  end;
  end;
end;

end.
