{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: Additional "INI" controls
//******************************************************
//******************************************************

unit INICtrEx;

interface

uses
	SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,INISec,ComCtrls
 {$ifdef VER90},DateEdit{$endif};

type
{$ifdef VER90}
	TCfgDateEdit=class(TDateEdit)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
		procedure Change; override;

	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;
{$endif}

{$ifndef VER90}
	TCfgDateEdit=class(TDateTimePicker)
	private
		FINIEntry:TINIEntry;
    FOnChange:TNotifyEvent;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;

    procedure DateChanged(Sender:TObject);

    procedure Loaded; override;

	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;
{$endif}

implementation

{$ifdef VER90}
procedure TCfgDateEdit.SetINIEntry(INIE:TINIEntry);
begin
	FINIEntry:=INIE;

	if Text<>INIE.AsString then Text:=INIE.AsString;
end;

procedure TCfgDateEdit.Change;
begin
	inherited Change;

	if INIEntry<>nil then INIEntry.AsString:=Text;
end;

constructor TCfgDateEdit.Create(AOwner:TComponent);
begin
	inherited Create(AOwner);
end;
{$endif}

{$ifndef VER90}
procedure TCfgDateEdit.SetINIEntry(INIE:TINIEntry);
begin
	FINIEntry:=INIE;

	if Text<>INIE.AsString then Text:=INIE.AsString;
end;

procedure TCfgDateEdit.Loaded;
begin
	inherited Loaded;

	FOnChange:=OnChange;
  OnChange:=DateChanged;
end;

procedure TCfgDateEdit.DateChanged(Sender:TObject);
begin
	if INIEntry<>nil then INIEntry.AsString:=Text;

	if Assigned(FOnChange) then FOnChange(Sender);
end;

constructor TCfgDateEdit.Create(AOwner:TComponent);
begin
	inherited Create(AOwner);
end;
{$endif}
end.
