{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: Main form for exploring Initalization Database 
//******************************************************
//******************************************************

unit INIDsgnF;

interface

uses
	SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs, StdCtrls, Buttons, INIUtil, ExtCtrls,
	INISec,INIEnt,Spin,Mask, FSaver,Clipbrd,
	INIMis,Menus,ComCtrls,dsgnIntf, INITree, INIDsgn,
  INIFile{$ifndef VER90},LibIntf{$endif}{$ifdef VER90},LibMain{$endif},
  TypInfo,INIFOpt,ExptIntf,EditIntf, INISecEx, INISecDB,INIFindS,
  INIEntEx;

const
	WMU_REFRESHLV=WM_USER+1;

  CLVComponentNameIndex=5;

	CDirectionDescription:array[TCreateDirection] of string=('Top to bottom','Left to right');

  CIIComponent=21;
  CIIClass=22;
  CIIProperty=23;

  CResCannotPasteSection=20201;
  CResCannotPasteEntry=20202;
  CResErrorDuringInitialization=20203;
  CResErrorCreatingEntries=20204;
  CResCannotDeleteGroup=20205;
  CResCannotAddGroup=20206;
  CResINIDatabaseMissing=20207;

  CResDeleteGroup=20251;
  CResDeleteSection=20252;
  CResDeleteEntry=20253;
  CResDeleteSelectedItems=20254;

  CResSavingSectionAsTemplate=20221;
  CResGrabbingFormStructure=20222;
  CResGrabbingRegistryStructure=20223;
  CResGrabbingFileStructure=20224;
  CResGrabbingComponentStructure=20225;
  CResDeletingListItems=20226;
  CResCreatingSections=20227;

type
	ECancelLongJob=class(Exception);

	TTVImageIndex=(iiSection,iiSectionList,iiGroup,iiPublic,iiGroupPrivate,iiUserPrivate,iiField);

  TClpExtraInfo=record
  	PM:TPrivateMode;
    GroupName:string;
  end;

	TFieldExtraInfo=record
  	i:Integer;
    IsSection:Boolean;
    Section:TINICustomSection;
  end;

  TDoProcedure=procedure(C:TComponent;DistributedP,ExtraP:Pointer) of object;

  TfrmINIDatabase=class(TForm)
    pnlBottom: TPanel;
    pnlButtons: TAutoAlignPanel;
    listS: TSimpleListDistributor;
    listGroups: TSimpleListDistributor;
    listF: TSimpleListDistributor;
    FormSaver: TFormSaver;
    pnlMain: TPanel;
    pnlTree: TPanel;
    pnlLeft: TPanel;
    TV: TDBTreeView;
    ResizeLine: TLineForResizing;
    listPO: TSimpleListDistributor;
    popMenuTV: TPopupMenu;
    POPRun: TMenuItem;
    popMenuEntries: TPopupMenu;
    popMenuLV: TPopupMenu;
    LVCopy: TMenuItem;
    LVPaste: TMenuItem;
    LVDelete: TMenuItem;
    popMenuSections: TPopupMenu;
    pnlRight: TPanel;
    LV: TListView;
    POPRefresh: TMenuItem;
    TVCopy: TMenuItem;
    TVPaste: TMenuItem;
    N1: TMenuItem;
    TVDelete: TMenuItem;
    LVSep1: TMenuItem;
    LVAddColumn: TMenuItem;
    LVDeleteColumn: TMenuItem;
    INIDB: TINIDatabase;
    secMain: TINISection;
    secOptionsPopup: TINIEntryBoolean;
    secOptionsAutoRename: TINIEntryBoolean;
    secMainLeftW: TINIEntryInteger;
    secMainDefPrefix: TINIEntryString;
    secOptionsDefSection: TINIEntryOneOfStrings;
    secOptionsDefEntry: TINIEntryOneOfStrings;
    secMainGroupName: TINIEntryString;
    secSections: TINIMultiSection;
    INIEntrySubSection1: TINIEntrySubSection;
    secGroups: TINIMultiSection;
    secGroupsINIEntrySubSection1: TINIEntrySubSection;
    secFields: TINIMultiSection;
    secFieldsType: TINIEntryOneOfStrings;
    secFieldsDisplayLabel: TINIEntryString;
    secFieldsDisplayWidth: TINIEntryInteger;
    secFieldsVisible: TINIEntryBoolean;
    secFieldsCalculated: TINIEntryBoolean;
    secGroupsColumns: TINIEntryInteger;
    secSectionsType: TINIEntryOneOfStrings;
    secSectionsGroupType: TINIEntryOneOfStrings;
    secSectionsRuntimeFile: TINIEntryBoolean;
    secSectionsFileName: TINIEntryString;
    secSectionsDestination: TINIEntryOneOfStrings;
    secSectionsRows: TINIEntryInteger;
    secSectionsHeight: TINIEntryInteger;
    pnlPath: TPanel;
    secOptionsCurrentPath: TINIEntryBoolean;
    secOptionsPathUpDown: TINIEntryOneOfStrings;
    pnlTools: TPanel;
    pnlSB: TAutoAlignPanel;
    SBPopup: TSpeedButton;
    SBCopy: TSpeedButton;
    SBPaste: TSpeedButton;
    secUserOptionsShowToolBar: TINIEntryBoolean;
    SBDelete: TSpeedButton;
    secMainINIEntrySubSection2: TINIEntrySubSection;
    secOptions: TINISection;
    INIEntrySubSection2: TINIEntrySubSection;
    pnlToolRight: TAutoAlignPanel;
    SBAbout: TSpeedButton;
    TVInspect: TMenuItem;
    OD: TOpenDialog;
    secMainFilterIndex: TINIEntryInteger;
    secMainInitialDir: TINIEntryString;
    secMainGrabGroupType: TINIEntryOneOfStrings;
    secMainGrabRows: TINIEntryInteger;
    secOptionsWarnDupFieldName: TINIEntryBoolean;
    secGrabbers: TINIMultiSection;
    secGrabbersForceString: TINIEntryBoolean;
    secGrabbersForceDW: TINIEntryInteger;
    imgList: TImageList;
    secOptionsProcessMessages: TINIEntryBoolean;
    secMainConfirmDeleteEntry: TINIEntryBoolean;
    secMainConfirmDeleteGroup: TINIEntryBoolean;
    secMainConfirmDeleteSection: TINIEntryBoolean;
    secOptionsShowLV: TINIEntryBoolean;
    secMainINIEntrySubSection4: TINIEntrySubSection;
    secUserOptions: TINIMultiSection;
    secFieldsCaptionstyle: TINIEntryOneOfStrings;
    secShortCuts: TINIMultiSection;
    secShortCutsShortCut: TINIEntryString;
    POPSaveShortCut: TMenuItem;
    SBShortCuts: TSpeedButton;
    SBInspect: TSpeedButton;
    SBSectionRun: TSpeedButton;
    popShortCuts: TPopupMenu;
    BBOptions: TBitBtn;
    BBClose: TBitBtn;
    BBHelp: TBitBtn;
    Edit1: TMenuItem;
    POPShortCutsSeparator: TMenuItem;
    secOptionsShowInspector: TINIEntryBoolean;
    secToolBarOpenpopupmenu: TINIEntryBoolean;
    secToolBarCopy: TINIEntryBoolean;
    secToolBarPaste: TINIEntryBoolean;
    secToolBarDelete: TINIEntryBoolean;
    secToolBarBookmarks: TINIEntryBoolean;
    secToolBarInspect: TINIEntryBoolean;
    secToolBarRun: TINIEntryBoolean;
    secFieldsDefaultValue: TINIEntryString;
    secFieldsItems1: TINIEntrySaveList;
    secFieldsItems2: TINIEntrySaveList;
    SBRun: TSpeedButton;
    secToolBarRunSection: TINIEntryBoolean;
    POPExpandAll: TMenuItem;
    N2: TMenuItem;
    LVSetGroup: TMenuItem;
    LVSep2: TMenuItem;
    secShortcutsOpenOnStart: TINIEntryBoolean;
    secUserOptionsOpenOnStart: TINIEntryBoolean;
    LVSep0: TMenuItem;
    LVInspect: TMenuItem;
    secUserOptionsOpenShortcuts: TINIEntryBoolean;
    secGroupsDirection: TINIEntryOneOfStrings;
    secGrabbersNewGroupSS: TINIEntryBoolean;
    Openall1: TMenuItem;
    secSectionsSectionName: TINIEntryString;
    secOptionsShowProgressDialog: TINIEntryBoolean;
    lblProgress: TLabel;
    ProgressBar: TProgressBar;
    INIEntrySubSection4: TINIEntrySubSection;
    secOptionsINIEntrySubSection5: TINIEntrySubSection;
    secGrabbersColumns: TINIEntryInteger;
    secGrabbersDirection: TINIEntryOneOfStrings;
    secMainINIEntrySubSection5: TINIEntrySubSection;
    INIEntrySubSection5: TINIEntrySubSection;
    secTesting: TINISection;
    secTestingResizeable: TINIEntryBoolean;
    secTestingINIEntrySubSection6: TINIEntrySubSection;
    secFont: TINISectionFont;
    secMainRegistryPath: TINIEntryString;
    secOptionsSaveRPath: TINIEntryBoolean;
    secOptionsShowResizing: TINIEntryBoolean;
    secOptionsRefreshTV: TINIEntryBoolean;
    secOptionsDeleteItems: TINIEntryBoolean;
    secMainINIEntrySubSection3: TINIEntrySubSection;
    secOptionsAlwaysRebuildTreeStructureAfterExpand: TINIEntryBoolean;
    secOptionsToolBarLocation: TINIEntryOneOfStrings;
    popToolBar: TPopupMenu;
    TBTop: TMenuItem;
    TBBottom: TMenuItem;
    TBLeft: TMenuItem;
    TBRight: TMenuItem;
    N3: TMenuItem;
    Hide1: TMenuItem;
    TVCopyName: TMenuItem;
    LVCopyName: TMenuItem;
    popPath: TPopupMenu;
    PTHTop: TMenuItem;
    PTHBottom: TMenuItem;
    N4: TMenuItem;
    Hide2: TMenuItem;
    N5: TMenuItem;
    Customize1: TMenuItem;
    secGrabbersCStyle: TINIEntryOneOfStrings;
    secUserOptionsDefPLPublic: TINIEntryInteger;
    secUserOptionsDefPLGroup: TINIEntryInteger;
    secUserOptionsDefPLUser: TINIEntryInteger;
    secToolBar: TINISection;
    secGrabbersGTP: TINIEntryOneOfStrings;
    imgListINI: TImageList;
    secFilters: TINIMultiSection;
    secFiltersFilter: TINIEntryString;
    secState: TINISection;
    LVSelectAll: TMenuItem;
    Invertselection1: TMenuItem;
    secGrabbersInteger: TINIEntryOneOfStrings;
    secGrabbersString: TINIEntryOneOfStrings;
    secGrabbersBoolean: TINIEntryOneOfStrings;
    secGrabbersFloat: TINIEntryOneOfStrings;
    secGrabbersBinary: TINIEntryOneOfStrings;
    Specialcopy1: TMenuItem;
    TVCopyCreationCode: TMenuItem;
    secStateBooleanValues: TINIEntryString;
    Specialcopy2: TMenuItem;
    LVCopyCreationCode: TMenuItem;
    procedure listSCustomizeList(Sender: TObject; Node:TTreeNode;List: TStringList);
    procedure listGroupsCustomizeList(Sender: TObject; Node:TTreeNode;List: TStringList);
    procedure listFCustomizeList(Sender: TObject; Node:TTreeNode;List: TStringList);
    procedure TVKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TVChange(Sender: TObject; Node: TTreeNode);
    procedure POPRunClick(Sender: TObject);
    procedure listGroupsEdited(Sender: TObject; EditedNode: TTreeNode;
      var S: string);
    procedure listGroupsExecuteVerb(Sender: TObject; PopupNode: TTreeNode;
      Verb: Integer);
    procedure listSEdited(Sender: TObject; EditedNode: TTreeNode;
      var S: string);
    procedure listFExecuteVerb(Sender: TObject; PopupNode: TTreeNode;
      Verb: Integer);
    procedure listFEdited(Sender: TObject; EditedNode: TTreeNode;
      var S: string);
    procedure listSExecuteVerb(Sender: TObject; PopupNode: TTreeNode;
      Verb: Integer);
    procedure listPODragOver(Sender: TObject; DragNode,
      AcceptNode: TTreeNode; const DragParamName: string;
      var Accept: Boolean);
    procedure listPODragDrop(Sender: TObject; DropNode,
      AcceptNode: TTreeNode; const DropParamName: string);
    procedure listFDragOver(Sender: TObject; DragNode,
      AcceptNode: TTreeNode; const DragParamName: string;
      var Accept: Boolean);
    procedure listFDragDrop(Sender: TObject; DropNode,
      AcceptNode: TTreeNode; const DropParamName: string);
    procedure listGroupsDragOver(Sender: TObject; DragNode,
      AcceptNode: TTreeNode; const DragParamName: string;
      var Accept: Boolean);
    procedure listGroupsDragDrop(Sender: TObject; DropNode,
      AcceptNode: TTreeNode; const DropParamName: string);
    procedure listPOExecuteVerb(Sender: TObject; PopupNode: TTreeNode;
      Verb: Integer);
    procedure FormShow(Sender: TObject);
    procedure LVChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure LVKeyPress(Sender: TObject; var Key: Char);
    procedure listPOCustomizeList(Sender: TObject; Node:TTreeNode;List: TStringList);
    procedure LVKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LVDeleteClick(Sender: TObject);
    procedure POPRefreshClick(Sender: TObject);
    procedure BBCloseClick(Sender: TObject);
    procedure popMenuTVPopup(Sender: TObject);
    procedure TVDeleteClick(Sender: TObject);
    procedure popMenuLVPopup(Sender: TObject);
    procedure LVCopyClick(Sender: TObject);
    procedure TVCopyClick(Sender: TObject);
    procedure LVPasteClick(Sender: TObject);
    procedure TVPasteClick(Sender: TObject);
    procedure LVAddColumnClick(Sender: TObject);
    procedure LVDeleteColumnClick(Sender: TObject);
    procedure listSDragOver(Sender: TObject; DragNode,
      AcceptNode: TTreeNode; const DragParamName: string;
      var Accept: Boolean);
    procedure listSDragDrop(Sender: TObject; DropNode,
      AcceptNode: TTreeNode; const DropParamName: string);
    procedure BBOptionsClick(Sender: TObject);
    procedure secMainGroupNameChange(Sender: TINIField);
    procedure secOptionsAutoRenameChange(Sender: TINIField);
    procedure secSectionsTypeInit(Sender: TINIField);
    procedure secFieldsTypeInit(Sender: TINIField);
    procedure TVEnter(Sender: TObject);
    procedure secOptionsCurrentPathChange(Sender: TINIField);
    procedure secOptionsPathUpDownChange(Sender: TINIField);
    procedure FormResize(Sender: TObject);
    procedure SBPopupClick(Sender: TObject);
    procedure secUserOptionsShowToolBarChange(Sender: TINIField);
    procedure SBPasteClick(Sender: TObject);
    procedure SBCopyClick(Sender: TObject);
    procedure SBDeleteClick(Sender: TObject);
    procedure SBSectionRunClick(Sender: TObject);
    procedure secSectionsDestinationInit(Sender: TINIField);
    procedure LVEnter(Sender: TObject);
    procedure SBAboutClick(Sender: TObject);
    procedure TVInspectClick(Sender: TObject);
    procedure SBInspectClick(Sender: TObject);
    procedure secOptionsWarnDupFieldNameChange(Sender: TINIField);
    procedure BBHelpClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure secOptionsShowLVChange(Sender: TINIField);
    procedure FormHide(Sender: TObject);
    procedure POPSaveShortCutClick(Sender: TObject);
    procedure SBShortCutsClick(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure popShortCutsPopup(Sender: TObject);
    procedure secToolBarOpenpopupmenuChange(Sender: TINIField);
    procedure secToolBarShowAllClick(Sender: TObject);
    procedure SBRunClick(Sender: TObject);
    procedure POPExpandAllClick(Sender: TObject);
    procedure LVSetGroupClick(Sender: TObject);
    procedure LVInspectClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TVKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure TVMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Openall1Click(Sender: TObject);
    procedure secOptionsDefEntryInit(Sender: TINIField);
    procedure secFieldsTypeChange(Sender: TINIField);
    procedure secFieldsBeforeEdit(Sender: TObject);
    procedure LVClick(Sender: TObject);
    procedure secOptionsShowResizingChange(Sender: TINIField);
    procedure secMainLeftWBeforeWrite(Sender: TINIField);
    procedure LVDblClick(Sender: TObject);
    procedure TVClick(Sender: TObject);
    procedure secGrabbersChange(Sender: TObject);
    procedure secOptionsAlwaysRebuildTreeStructureAfterExpandChange(
      Sender: TINIField);
    procedure secOptionsToolBarLocationChange(Sender: TINIField);
    procedure TBRightClick(Sender: TObject);
    procedure Hide1Click(Sender: TObject);
    procedure LVCopyNameClick(Sender: TObject);
    procedure TVCopyNameClick(Sender: TObject);
    procedure popToolBarPopup(Sender: TObject);
    procedure Hide2Click(Sender: TObject);
    procedure popPathPopup(Sender: TObject);
    procedure PTHBottomClick(Sender: TObject);
    procedure Customize1Click(Sender: TObject);
    procedure INIDBAfterRead(Sender: TObject);
    procedure LVSelectAllClick(Sender: TObject);
    procedure Invertselection1Click(Sender: TObject);
    procedure secGrabbersIntegerInit(Sender: TINIField);
    procedure TVCopyCreationCodeClick(Sender: TObject);

  private
  	FDoingLongJobValue,FRefreshLVLevel:Integer;
	 	FSaveHLPFile:string;
  	FLVGroups:Boolean;
    FInitializationLevel:Integer;
  	FLastSelectedParam,FLongJobTitle:string;
    FLastNode:TTreeNode;
    FClpOwner,FClpParent:TComponent;
    FClpComponents,FSelectedComponents:TComponentList;
    FClpExtraInfo:TClpExtraInfo;
    FINIOptions:TfrmINIOptions;
    FClosing:Boolean;

		function NotCancelException(E:Exception):Boolean;

    procedure ComponentRenamed(ComponentHandle:Pointer;const OldName,NewName:string);

		procedure PostRefreshLV;
    procedure WMRefreshLV(var Msg:TMessage); message WMU_REFRESHLV;

    procedure BeginInitialization;
    procedure EndInitialization;

    function GetMinXSize:Integer;
    function GetMinYSize:Integer;

		procedure DoBeforeShow;

		procedure EditOptions(Section,EditSection:TINICustomSection;const Title,EditGroup:string;W,H:Integer;ResetEnabled:Boolean);

    procedure SetPathLocation;
    procedure SetToolBarLocation;

		procedure SaveAsShortCut(Node:TTreeNode);
		procedure OpenShortCutMenu;

    procedure OpenShortCuts(Open,All:Boolean);
    procedure ReadShortCuts;
    procedure WriteShortCuts;

    procedure InitSectionTypes(Sender: TINIField;lCount:Integer);
    procedure InitEntryTypes(Sender: TINIField);

		procedure InitTV;
		procedure InitToolBar;
    
		function CountToolBarVisibleButtons:Integer;

		procedure IamInitialized;

		procedure SyncronizeTV;
    
		procedure AdvanceProgressBar(Step:Integer);
    procedure OpenProgressDialog(const Title:string;Open:Boolean);
    procedure CloseProgressDialog;

    procedure BeginLongJob(const Title:string);
    procedure EndLongJob;
    procedure DoingLongJob(AlwaysProcessMessages,Progress:Boolean;Position:Integer);

    procedure GoAbout;

		function CreateGrabbedSection(SectionClass:TClassOfINISection;PM:TPrivateMode;const sName,fName,fDestination:string):TINICustomSection;

		function GetFormComponent:TComponent;

		function GrabStructureFromFile(PM:TPrivateMode;FromRegistry:Boolean):Integer;
		function GrabStructureFromForm(PM:TPrivateMode;GrabFromForm:TForm):Integer;
		function GrabStructureFromComponent(PM:TPrivateMode;C:TObject):Integer;

		function SaveSectionAsTemplate(Section:TINICustomSection;Replace:Boolean):string;
    
    procedure ReaderSetName(Reader:TReader;Component:TComponent;var Name:string);
    procedure ComponentRead(Component:TComponent);
    
		function ClipboardComponents:Boolean;
    
    procedure CopyComponents(Root: TComponent;Components:TComponentList);
    procedure PasteComponents(AOwner,AParent:TComponent;Components:TComponentList);

		procedure EnableClipboardCommands;
    
    procedure DoPaste;

    procedure DoTVCopy;
    procedure DoTVPaste;
    procedure DoTVDelete;
    
    procedure DoLVCopy;
    procedure DoLVPaste;
    procedure DoLVDelete;

    procedure LVBeginUpdate;
    procedure LVEndUpdate;

		procedure InitSectionClasses;
		procedure InitEntryClasses;

		procedure DeleteTVNode(Node:TTreeNode;const ParamName:string);

		procedure AddLVColumn(const Caption:string);
		procedure AddLVItem(const ComponentName,Caption:string;SubCaptions:array of string;ImageIndex:Integer);

		procedure SetLVColumns(Captions:array of string);
		procedure DeleteLVItems;

    procedure ListPOSelected;
    procedure ListSSelected;
    procedure ListGroupsSelected;
    procedure ListFSelected;

    procedure ListPOFillLV;
    procedure ListSFillLV;
    procedure ListGroupsFillLV;
    procedure ListFFillLV;

		function GetLVSelections:TComponentList;
		procedure SetLVSelections;

		procedure SetGroupAttributes(Section:TINICustomSection;const gName:string);

		procedure DoGetSections(Node:TTreeNode;DoProc:TDoProcedure;DistributedP:Pointer);
		procedure DoGetGroups(Node:TTreeNode;DoProc:TDoProcedure;DistributedP:Pointer);
		procedure DoGetFields(Node:TTreeNode;DoProc:TDoProcedure;DistributedP:Pointer);

		procedure AddSectionsToTV(C:TComponent;DistributedP,ExtraP:Pointer);
		procedure AddSectionsToLV(C:TComponent;DistributedP,ExtraP:Pointer);

		procedure AddGroupsToTV(C:TComponent;DistributedP,ExtraP:Pointer);
		procedure AddGroupsToLV(C:TComponent;DistributedP,ExtraP:Pointer);
    
		procedure AddFieldsToTV(C:TComponent;DistributedP,ExtraP:Pointer);
		procedure AddFieldsToLV(C:TComponent;DistributedP,ExtraP:Pointer);

    procedure CreateINIEntries;

		procedure OnMenuEntriesClick(Sender:TObject);
		procedure OnMenuSectionsClick(Sender:TObject);

		procedure OnShortCutClick(Sender:TObject);
		procedure OnGrabFormStructureClick(Sender:TObject);
		procedure OnGrabComponentStructureClick(Sender:TObject);

		procedure GoTest(Node:TTreeNode;TestAll:Boolean);

  protected
  	FINIDatabase:TINIDatabase;
    FForm:TComponent;
    FDesigner:TFormDesigner;

		procedure WMGetMinMaxInfo(var Msg:TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

		function DestroyEntry(Entry:TINIEntry;Always:Boolean):Boolean;
		function DestroySection(Section:TINICustomSection;Always:Boolean):Boolean;

		procedure DeleteGroup(Node:TTreeNode);
		procedure DeleteEntry(Node:TTreeNode);
		procedure DeleteSection(Node:TTreeNode);

		procedure AddNewGroup(Node:TTreeNode);
		procedure AddNewEntry(Node:TTreeNode;EntryID:Integer);
		procedure AddNewSection(Node:TTreeNode;SectionID:Integer);

		procedure AddNewGroupInSection(Section:TINICustomSection;Node:TTreeNode);
		function MoveGroupToSection(DropNode,AcceptNode:TTreeNode;Index:Integer):Integer;

		function CreateNewSection(var INISectionClassID:Integer;PM:TPrivateMode;ParentSection:TINICustomSection):TINICustomSection;

		function CreateEntrySubSection(Section:TINICustomSection;const gName:string):TINIEntrySubSection;
		function CreateNewEntryByClass(INIEntryClass:TClassOfINIEntry;Section:TINICustomSection;const eName,gName:string):TINIEntry;
		function CreateNewEntry(var INIEntryClassID:Integer;Section:TINICustomSection;const gName:string):TINIEntry;

    function GetEntryClassByPropertyType(PPI:PPropInfo):TClassOfINIEntry; virtual;

		function GetParentSection:TINICustomSection;

		function GetSectionFromNode(Node:TTreeNode):TINICustomSection;
		function GetINISection(const sName:string):TINICustomSection;

		function GetEntryFromNode(Node:TTreeNode):TINIEntry;
		function GetINIEntry(const eName:string):TINIEntry;

		procedure ShowLV(ShowIt:Boolean);
		procedure RefreshLV(Node:TTreeNode;Select:Boolean);
		procedure SelectComponent;

    procedure Notification(AComponent: TComponent; Operation: TOperation); override;

		procedure CreateWnd; override;
    
  public
  	constructor Create(AOwner:TComponent); override;
  	destructor Destroy; override;

  	function Go(Designer:TFormDesigner;INIDatabase:TINIDatabase;Form:TComponent):Integer;

    property INIDatabase:TINIDatabase read FINIDatabase;
  end;

var frmINIDatabase:TfrmINIDatabase;

implementation

uses INITest,INIAbout,FNewFld,FNewSec,FNewGr,INISelC,FRegNode;

const CHLPFile='INIDb.HLP';

{$R *.DFM}

function PositionInFor(Counter,MaxValue:LongInt):LongInt;
begin
	if Counter=MaxValue then
  	Result:=100
  else
  	Result:=Min(100,Max(0,100*(Counter+1) div (MaxValue+1)));
end;

function SectionImageIndex(C:TComponent):Integer;
begin
	if C is TINICustomMultiSection then
  	Result:=Integer(iiSectionList)
  else
  	Result:=Integer(iiSection);
end;

function Confirm(const Msg:string;Ask:Boolean):Boolean;
begin
	Result:=not Ask;

  if Ask then Result:=MessageDlg(Msg,mtConfirmation,[mbYes,mbNo,mbCancel],0)=mrYes;
end;

function ShowMessage(const Msg:string):Boolean;
begin
	Result:=MessageDlg(Msg,mtInformation,[mbOk],0)=mrOk;
end;

function ShowError(const Msg:string):Boolean;
begin
	Result:=MessageDlg(Msg,mtError,[mbOk],0)=mrOk;
end;

constructor TfrmINIDatabase.Create(AOwner:TComponent);
begin
	FInitializationLevel:=0;
  FRefreshLVLevel:=0;
	FDoingLongJobValue:=0;
  FLVGroups:=False;
  FLongJobTitle:='';
  FClosing:=False;

	inherited Create(AOwner);

  CreateINIEntries;

  FINIOptions:=nil;
  
  FClpComponents:=TComponentList.Create;
  FSelectedComponents:=TComponentList.Create;
end;

destructor TfrmINIDatabase.Destroy;
begin
	FSelectedComponents.Free;
	FClpComponents.Free;

  if FINIOptions<>nil then FINIOptions.Free;

	inherited Destroy;
end;

procedure TfrmINIDatabase.CreateWnd;
begin
	inherited CreateWnd;
end;

procedure TfrmINIDatabase.ComponentRenamed(ComponentHandle:Pointer;const OldName,NewName:string);
begin
end;

function TfrmINIDatabase.NotCancelException(E:Exception):Boolean;
begin
	EndLongJob;

  Result:=not (E is ECancelLongJob); 
end;

procedure TfrmINIDatabase.BeginInitialization;
begin
	FInitializationLevel:=FInitializationLevel+1;
end;

procedure TfrmINIDatabase.EndInitialization;
begin
	if FInitializationLevel>0 then FInitializationLevel:=FInitializationLevel-1;
end;

procedure TfrmINIDatabase.ReaderSetName(Reader:TReader;Component:TComponent;var Name:string);

	function UniqueName(Component:TComponent;const DefName:string):string;
  var Counter:Integer;
  		CName:string;
  begin
  	Counter:=0;

    CName:=DefName;

    if Component is TINIField then with Component as TINIField do begin
    	if (Table<>nil) and (Table.Name<>'') then begin
      	CName:=Format('%s%s',[Table.Name,MakeIdent(FieldName)]);

        if FClpOwner.FindComponent(CName)=nil then begin
        	Result:=CName;

          Exit;
        end;
      end;
    end;

    repeat
    	Counter:=Counter+1;

	  	Result:=Format('%s%d',[DefName,Counter]);
    until FClpOwner.FindComponent(Result)=nil;
  end;

begin
	DoingLongJob(False,True,-1);

  if (Reader.Root=FClpOwner) and (FClpOwner.FindComponent(Name)<>nil) then Name:=UniqueName(Component,Name);
end;

procedure TfrmINIDatabase.ComponentRead(Component:TComponent);
var OK:Boolean;
		INIE:TINIEntry;
begin
	OK:=False;

	if Component is TINICustomSection then begin
  	OK:=FClpParent is TINIDatabase;

  	if OK then begin
	  	(Component as TINICustomSection).Database:=FClpParent as TINIDatabase;
      (Component as TINICustomSection).PrivateMode:=FClpExtraInfo.PM;
    end else begin
    	OK:=FClpParent is TINICustomSection;

      if OK then begin
      	INIE:=nil;

      	try
	      	INIE:=CreateEntrySubSection(FClpParent as TINICustomSection,FClpExtraInfo.GroupName);

  	      OK:=INIE<>nil;

    	    if OK then (INIE as TINIEntrySubSection).SubSection:=Component as TINICustomSection;

          except
          	on Exception do begin
            	if (INIE is TINIEntrySubSection) and ((INIE as TINIEntrySubSection).SubSection=nil) then DestroyEntry(INIE,True);

              raise;
            end;
        end;
    	end else
	    	ShowError(ResStr(CResCannotPasteSection));
    end;
  end else if Component is TINIEntry then begin
  	OK:=FClpParent is TINICustomSection;

  	if OK then begin
    	(Component as TINIEntry).Table:=FClpParent as TINICustomSection;

      if FClpExtraInfo.GroupName<>'' then
      	(Component as TINIEntry).GroupName:=FClpExtraInfo.GroupName
      else with FClpParent as TINICustomSection do begin
      	OK:=GroupExpandable;

        if OK then InsertGroup((Component as TINIEntry).GroupName,1,-1,cdTopToBottom,-1);
      end;
    end else
    	ShowError(ResStr(CResCannotPasteEntry));
  end;

  if not OK then FClpComponents.Add(Component);
end;

function TfrmINIDatabase.ClipboardComponents:Boolean;
begin
  Result:=Clipboard.HasFormat(CF_COMPONENTS) or (Clipboard.HasFormat(CF_TEXT) and PossibleStream(Clipboard.AsText));
end;

procedure TfrmINIDatabase.CopyComponents(Root:TComponent;Components:TComponentList);
var S:TMemoryStream;
  	W:TWriter;
  	i:Integer;
begin
  S:=TMemoryStream.Create;

  try
    W:=TWriter.Create(S,1024);

    try
      W.Root:=Root;

      for i:=0 to Components.Count-1 do begin
        W.WriteSignature;
        W.WriteComponent(TComponent(Components[i]));
      end;

      W.WriteListEnd;

	    finally
  	    W.Free;
    end;

    CopyStreamToClipboard(S);

	  finally
  	  S.Free;
  end;
end;

procedure TfrmINIDatabase.PasteComponents(AOwner,AParent:TComponent;Components:TComponentList);
var S:TStream;
  	R:TReader;
begin
  S:=GetClipboardStream;

  try
    R:=TReader.Create(S,1024);

    try
      R.OnSetName:=ReaderSetName;

      FClpOwner:=AOwner;
      FClpComponents:=Components;

      BeginLongJob('Pasting components ...');

      try
	      R.ReadComponents(AOwner,AParent,ComponentRead);

        EndLongJob;

        except
        	on E:Exception do begin
          	if NotCancelException(E) then raise;
          end;
      end;

	    finally
  	    R.Free;
    end;

	  finally
  	  S.Free;
  end;
end;

procedure TfrmINIDatabase.CreateINIEntries;
begin
	BeginInitialization;
  
	try
    secMain.ReadSection;

    pnlLeft.Width:=Min(pnlMain.ClientWidth-64,secMainLeftW.AsInteger);

    InitSectionClasses;
    InitEntryClasses;

    finally
		  EndInitialization;
  end;
end;

function TfrmINIDatabase.GetINISection(const sName:string):TINICustomSection;
var findC:TComponent;
begin
	Result:=nil;

  if sName<>'' then begin
		findC:=FForm.FindComponent(sName);

  	if findC<>nil then begin
    	if findC is TINICustomSection then
      	Result:=findC as TINICustomSection
      else if findC is TINIEntrySubSection then
      	Result:=(findC as TINIEntrySubSection).SubSection;
    end;
  end;
end;

function TfrmINIDatabase.GetINIEntry(const eName:string):TINIEntry;
var findC:TComponent;
begin
	Result:=nil;

  if eName<>'' then begin
		findC:=FForm.FindComponent(eName);

  	if findC is TINIEntry then Result:=findC as TINIEntry;
  end;
end;

function TfrmINIDatabase.GetParentSection:TINICustomSection;
begin
	Result:=GetSectionFromNode(TV.Selected);
end;

function TfrmINIDatabase.GetSectionFromNode(Node:TTreeNode):TINICustomSection;
var tParam,sName:string;
		INIE:TINIEntry;
    P:Pointer;
begin
	Result:=nil;

  if Node<>nil then begin
    tParam:=TV.LD[GetNodeLevel(Node)-1].ParamName;

    if tParam=listS.ParamName then begin
    	sName:=GetNodeID(Node);

      if sName<>'' then
	      Result:=GetINISection(sName)
      else begin
      	P:=TNodeObject(Node.Data).Data;

        if P<>nil then begin
        	try
	        	Result:=TINICustomSection(P);

            except
            	Result:=nil;
          end;
        end;
      end;
    end else if tParam=listGroups.ParamName then begin
    	sName:=GetNodeID(Node.Parent);

      if sName<>'' then
	      Result:=GetINISection(sName)
      else if Node.Parent<>nil then begin
      	P:=TNodeObject(Node.Parent.Data).Data;

        if P<>nil then begin
        	try
            if TObject(P) is TINIEntryLink then
              Result:=TINIEntryLink(P).SubSection
            else if TObject(P) is TINICustomSection then
              Result:=TINICustomSection(P)

            except
            	Result:=nil;
          end;
        end;
      end;
    end else if tParam=listF.ParamName then begin
      INIE:=GetEntryFromNode(Node);

      if INIE is TINIEntrySubSection then
        Result:=(INIE as TINIEntrySubSection).SubSection
      else begin
				sName:=GetNodeID(Node.Parent.Parent);

        if sName<>'' then
					Result:=GetINISection(sName)
				else if Node.Parent.Parent<>nil then begin
      	  P:=TNodeObject(Node.Parent.Parent.Data).Data;

          if P<>nil then begin
        		try
              if TObject(P) is TINIEntryLink then
                Result:=TINIEntryLink(P).SubSection
              else if TObject(P) is TINICustomSection then
                Result:=TINICustomSection(P)

             	except
            		Result:=nil;
            end;
          end;
        end;
      end;
    end;
  end;
end;

function TfrmINIDatabase.GetEntryClassByPropertyType(PPI:PPropInfo):TClassOfINIEntry;
var PTI:PTypeInfo;
begin
	Result:=nil;

{$ifdef VER90}
	PTI:=PPI.PropType;
{$endif}
{$ifndef VER90}
	PTI:=PPI.PropType^;
{$endif}

  if PPI<>nil then begin
    if PTI.Kind=tkInteger then
      Result:=TINIEntryInteger
    else if PTI.Kind in [tkString,tkLString{$ifdef VER90},tkLWString{$endif}] then
      Result:=TINIEntryString
    else if PTI.Kind=tkFloat then
      Result:=TINIEntryFloat
    else if PTI.Kind=tkEnumeration then
    	Result:=TINIEntryOneOfStrings
    else if PTI.Kind=tkSet then
    	Result:=TINIEntryManyOfStrings
    else if PTI.Kind=tkClass then begin
    	if (PTI=TStrings.ClassInfo) or (PTI=TStringList.ClassInfo) then
      	Result:=TINIEntrySaveList;
    end;
  end;
end;

function TfrmINIDatabase.Go(Designer:TFormDesigner;INIDatabase:TINIDatabase;Form:TComponent):Integer;
begin
	try
    BeginInitialization;

    try
      FINIDatabase:=INIDatabase;
      FForm:=Form;
      FDesigner:=Designer;

      if FForm<>nil then begin
      	FForm.FreeNotification(Self);
      end;

      if FINIDatabase<>nil then FINIDatabase.FreeNotification(Self);

      InitTV;

      if not Visible then Show;

     	BringToFront;

      finally
        EndInitialization;
    end;

    except
    	on Exception do begin
      	ShowError(ResStr(CResErrorDuringInitialization));

        Close;
      end;
  end;

  Result:=mrOK;
end;

procedure TfrmINIDatabase.InitTV;
begin
  TV.DeleteAll;
  TV.Init(False);

  if Visible then begin
	  ReadShortCuts;
 		OpenShortCuts(secUserOptionsOpenShortcuts.AsBoolean,False);
  end;
end;

procedure TfrmINIDatabase.DoGetSections(Node:TTreeNode;DoProc:TDoProcedure;DistributedP:Pointer);
var i,cc,selI:Integer;
    INIS:TINICustomSection;
begin
  selI:=StrToInt(GetNodeID(Node));

  cc:=FForm.ComponentCount-1;

  for i:=0 to cc do begin
    if FForm.Components[i] is TINICustomSection then begin
      INIS:=FForm.Components[i] as TINICustomSection;

      if (INIS.Database=FINIDatabase) and ((INIS.PrivateMode=TPrivateMode(selI)) or (selI=3)) then begin
        if not INIS.Son then begin
          DoProc(INIS,DistributedP,nil);
        end;
      end;
    end;
  end;
end;

procedure TfrmINIDatabase.AddSectionsToTV(C:TComponent;DistributedP,ExtraP:Pointer);
begin
	TStringList(DistributedP).AddObject((C as TINICustomSection).SectionName,TNodeObject.CreateImageComponent(C.Name,SectionImageIndex(C),C));
end;

procedure TfrmINIDatabase.listSCustomizeList(Sender: TObject; Node:TTreeNode;List: TStringList);
begin
	DoGetSections(TV.ExpandingNode,AddSectionsToTV,List);
end;

procedure TfrmINIDatabase.DoGetGroups(Node:TTreeNode;DoProc:TDoProcedure;DistributedP:Pointer);
var sSelection:string;
		i,gc:Integer;
    INIS:TINICustomSection;
    parC:TComponent;
    P:Pointer;
begin
	sSelection:=GetNodeID(Node);

  if sSelection<>'' then
	  parC:=FForm.FindComponent(sSelection)
  else begin
  	parC:=nil;

  	P:=TNodeObject(Node.Data).Data;

    if P<>nil then begin
    	try
	    	parC:=TINICustomSection(P);

        except
        	parC:=nil;
      end;
    end;
  end;

  if parC<>nil then begin
  	INIS:=nil;

  	if parC is TINICustomSection then
	  	INIS:=parC as TINICustomSection
    else if parC is TINIEntrySubSection then
    	INIS:=(parC as TINIEntrySubSection).SubSection;

    if INIS<>nil then begin
      gc:=INIS.GroupCount-1;

      for i:=0 to gc do begin
        if INIS.Group[i]<>'' then begin
        	DoProc(INIS,DistributedP,@i);
        end;
      end;
    end;
  end;
end;

procedure TfrmINIDatabase.listGroupsCustomizeList(Sender: TObject;Node:TTreeNode;List: TStringList);
begin
	DoGetGroups(TV.ExpandingNode,AddGroupsToTV,List);
end;

procedure TfrmINIDatabase.AddGroupsToTV(C:TComponent;DistributedP,ExtraP:Pointer);
begin
  TStringList(DistributedP).AddObject((C as TINICustomSection).Group[Integer(ExtraP^)],TNodeObject.CreateImage((C as TINICustomSection).Group[Integer(ExtraP^)],Integer(iiGroup)));
end;

procedure TfrmINIDatabase.listFCustomizeList(Sender: TObject; Node:TTreeNode;List: TStringList);
begin
	DoGetFields(TV.ExpandingNode,AddFieldsToTV,List);
end;

procedure TfrmINIDatabase.AddFieldsToTV(C:TComponent;DistributedP,ExtraP:Pointer);
var i,ii:Integer;
		INIS:TINICustomSection;
    cC:TComponent;
begin
	i:=TFieldExtraInfo(ExtraP^).i;

  cC:=(C as TINICustomSection).Fields[i];

	if TFieldExtraInfo(ExtraP^).IsSection then begin
	  INIS:=TFieldExtraInfo(ExtraP^).Section;

  	TStringList(DistributedP).AddObject(INIS.SectionName,TNodeObject.CreateImageComponent(cC.Name,SectionImageIndex(INIS),cC));
  end else begin
  	ii:=Integer(iiField)+GetEntryClassImageIndexByName(cC.ClassName);

   	TStringList(DistributedP).AddObject(TINIEntry(cC).DisplayLabel,TNodeObject.CreateImageChildComponent(cC.Name,ii,False,cC));
  end;
end;

procedure TfrmINIDatabase.DoGetFields(Node:TTreeNode;DoProc:TDoProcedure;DistributedP:Pointer);
var GroupName:string;
		INIS,iniSS:TINICustomSection;
    i,fc:Integer;
    ExtraInfo:TFieldExtraInfo;
begin
  GroupName:=GetNodeID(Node);

  if GroupName<>'' then begin
  	INIS:=GetSectionFromNode(Node);

    if INIS<>nil then begin
    	fc:=INIS.FieldCount-1;

      for i:=0 to fc do begin
      	ExtraInfo.i:=i;

      	if CompareText((INIS.Fields[i] as TINIEntry).GroupName,GroupName)=0 then begin
        	if INIS.Fields[i] is TINIEntrySubSection then begin
          	iniSS:=(INIS.Fields[i] as TINIEntrySubSection).SubSection;

            if iniSS<>nil then begin
            	ExtraInfo.IsSection:=True;
            	ExtraInfo.Section:=iniSS;

		        	DoProc(INIS,DistributedP,@ExtraInfo);
            end;
          end else begin
           	ExtraInfo.IsSection:=False;

	        	DoProc(INIS,DistributedP,@ExtraInfo);
          end;
        end;
      end;
    end;
  end;
end;

function TfrmINIDatabase.CreateNewSection(var INISectionClassID:Integer;PM:TPrivateMode;ParentSection:TINICustomSection):TINICustomSection;
var frmNewSection:TfrmNewSection;
		newC:TComponent;
    nS:Integer;
    lFileName,lDestination:string;

	procedure AddFromTemplates(Section:TINICustomSection;const TemplateName:string;Progress:Boolean);
  var i,j,Errors:Integer;
  		INIE:TINIEntry;
      EntryClass:TClassOfINIEntry;

  	procedure CreateSubSectionFromTemplate(const gName:string);
    var nEntry:TINIEntry;
    		newS:TINICustomSection;
        FSSSections,FSSGroups,FSSFields:string;

    	procedure PushState;
      begin
      	FSSFields:=secFields.Key;
        FSSGroups:=secGroups.Key;
        FSSSections:=secSections.Key;
      end;

      procedure PopState;
      begin
        secSections.Key:=FSSSections;
        secGroups.Key:=FSSGroups;
        secFields.Key:=FSSFields;
      end;

    begin
    	nEntry:=CreateEntrySubSection(Section,gName);

      if nEntry is TINIEntrySubSection then begin
      	PushState;

      	try
        	newS:=nil;

        	secSections.Key:=secFieldsDisplayLabel.AsString;

          try
            newS:=FDesigner.CreateComponent(GetSectionClass(secSectionsType.AsInteger),FForm,20,20,32,32) as TINICustomSection;

            with newS do begin
            	Database:=FINIDatabase;
              SectionName:=secSectionsSectionName.AsString;
              FileName:=secSectionsFileName.AsString;
              Destination:=secSectionsDestination.AsString;
              GroupType:=TGroupType(secSectionsGroupType.AsInteger);
              Rows:=secSectionsRows.AsInteger;
              Height:=secSectionsHeight.AsInteger;
              ParentDestination:=secSectionsRuntimeFile.AsBoolean;
              PrivilegLevel:=FINIDatabase.UserPrivilegLevel;

              try
                newS.Name:=OnlyAlnum(secMainDefPrefix.AsString)+MakeIdent(SectionName);

                except
                  on E:Exception do begin
                  	if E is ECancelLongJob then raise;
                  end;
              end;
            end;

            finally
	 		 	      (nEntry as TINIEntrySubSection).SubSection:=newS;
          end;

          AddFromTemplates(newS,secSections.Key,False);

          finally
          	PopState;
        end;
      end;
    end;

  begin
  	Errors:=0;

    secSections.Key:=TemplateName;

    for i:=0 to secGroups.KeyCount-1 do begin
    	DoingLongJob(False,Progress,PositionInFor(i,secGroups.KeyCount-1));

      secGroups.KeyIndex:=i;

      if i=0 then begin
        Section.RenameGroup(Section.Group[0],secGroups.Key);

        Section.ColumnsInGroup[0]:=secGroupsColumns.AsInteger;
        Section.DirectionInGroup[0]:=TCreateDirection(secGroupsDirection.AsInteger);
      end else
        Section.InsertGroup(secGroups.KeyByIndex[i],secGroupsColumns.AsInteger,-1,TCreateDirection(secGroupsDirection.AsInteger),-1);

      for j:=0 to secFields.KeyCount-1 do begin
      	secFields.KeyIndex:=j;

        if secFieldsType.AsInteger<GetEntryClassesCount then begin
        	try
            EntryClass:=GetEntryClass(secFieldsType.AsInteger);

            INIE:=CreateNewEntryByClass(EntryClass,Section,secFields.Key,secGroups.Key);

            with INIE do begin
              DefaultAsString:=secFieldsDefaultValue.AsString;
              DisplayLabel:=secFieldsDisplayLabel.AsString;
              DisplayWidth:=secFieldsDisplayWidth.AsInteger;
              Visible:=secFieldsVisible.AsBoolean;
              Calculated:=secFieldsCalculated.AsBoolean;
              CaptionStyle:=TCaptionStyle(secFieldsCaptionStyle.AsInteger);

              if INIE is TINIEntryItems then with INIE as TINIEntryItems do begin
                Items.Assign(secFieldsItems1.List);
                Descriptions.Assign(secFieldsItems2.List);
              end else if INIE is TINIEntrySaveList then with INIE as TINIEntrySaveList do begin
                StaticList.Assign(secFieldsItems1.List);
              end;

              Name:=Section.Name+MakeIdent(FieldName);
            end;

            except
              on E:Exception do begin
               	if E is ECancelLongJob then raise;
                
              	Errors:=Errors+1;
              end;
	        end;
        end else begin
        	CreateSubSectionFromTemplate(secGroups.Key);
        end;
      end;
    end;

    if Errors>0 then ShowError(ResStr(CResErrorCreatingEntries));
  end;

begin
	Result:=nil;

  frmNewSection:=TfrmNewSection.Create(Self);

  with frmNewSection do try
  	lFileName:=FINIDatabase.FileName;
    lDestination:=FINIDatabase.Destination;

    if ParentSection<>nil then begin
      lFileName:=ParentSection.FileName;
      lDestination:=ParentSection.Destination;
    end;

  	if frmNewSection.GetSectionData(secMainDefPrefix.AsString,lFileName,lDestination,INISectionClassID,secSections)=mrOK then begin
    	if ESectionName.Text<>'' then begin
        nS:=frmNewSection.CMBType.ItemIndex;

        newC:=FDesigner.CreateComponent(GetSectionClass(nS),FForm,20,20,32,32);

        if newC is TINICustomSection then begin
          Result:=newC as TINICustomSection;

          with Result do begin
            Database:=FINIDatabase;
            SectionName:=ESectionName.Text;
            FileName:=EFileName.Text;
            GroupType:=TGroupType(CMBGroupType.ItemIndex);
            Destination:=CMBDestination.Text;
            PrivateMode:=PM;
            Height:=EHeight.Value;
            Rows:=ERows.Value;
            ParentDestination:=False;

            if PM=pmPublic then
	            PrivilegLevel:=secUserOptionsDefPLPublic.AsInteger
            else if PM=pmGroupPrivate then
	            PrivilegLevel:=secUserOptionsDefPLGroup.AsInteger
            else
	            PrivilegLevel:=secUserOptionsDefPLUser.AsInteger;

            if ECName.Text<>'' then begin
            	try
	            	Result.Name:=ECName.Text;

                except
                	on E:Exception do begin
                  	if E is ECancelLongJob then raise;
                  end;
              end;
            end;
          end;

          if CMBTemplate.ItemIndex>0 then begin
          	BeginLongJob(ResStr(CResCreatingSections));

            try
          		AddFromTemplates(Result,CMBTemplate.Text,True);

             	EndLongJob;
              
              except
              	on E:Exception do begin
                  if NotCancelException(E) then raise;
                end;
            end;
          end;

          FDesigner.Modified;
        end;

				secOptionsDefSection.AsInteger:=nS;
        INISectionClassID:=nS;
      end;
    end;

    finally
    	frmNewSection.Free;
  end;
end;

function TfrmINIDatabase.CreateNewEntryByClass(INIEntryClass:TClassOfINIEntry;Section:TINICustomSection;const eName,gName:string):TINIEntry;
var newC:TComponent;
begin
	Result:=nil;

	newC:=FDesigner.CreateComponent(INIEntryClass,FForm,20,20,32,32);

  if newC<>nil then begin
    Result:=newC as TINIEntry;

    Result.PrivilegLevel:=Section.PrivilegLevel;

    try
     	Result.FieldName:=strIf(eName='',Result.Name,eName);

      finally
        Result.Table:=Section;
    end;

    Result.GroupName:=gName;

    try
      Result.Name:=Section.Name+MakeIdent(Result.FieldName);

      except
        on E:Exception do begin
         	if E is ECancelLongJob then raise;
        end;
    end;
  end;
end;

function TfrmINIDatabase.CreateEntrySubSection(Section:TINICustomSection;const gName:string):TINIEntrySubSection;
var newC:TComponent;
begin
	Result:=nil;

	newC:=FDesigner.CreateComponent(TINIEntrySubSection,FForm,20,20,32,32);

  if newC<>nil then begin
    Result:=newC as TINIEntrySubSection;

    Result.Table:=Section;
   	Result.FieldName:='';
    Result.Name:='';
    Result.GroupName:=gName;
    Result.PrivilegLevel:=Section.PrivilegLevel;
  end;
end;

function TfrmINIDatabase.CreateNewEntry(var INIEntryClassID:Integer;Section:TINICustomSection;const gName:string):TINIEntry;
var frmNewField:TfrmNewField;
    newC:TComponent;
    nE:Integer;
begin
	Result:=nil;

	frmNewField:=TfrmNewField.Create(Self);

  with frmNewField do try
  	if GetEntryData(Section.Name,'',Section.PrivilegLevel,INIEntryClassID)=mrOK then begin
    	nE:=CMBType.ItemIndex;

    	if EFieldName.Text<>'' then begin
        newC:=FDesigner.CreateComponent(GetEntryClass(nE),FForm,20,20,32,32);

        if newC<>nil then begin
          Result:=newC as TINIEntry;

          with Result do begin
            Calculated:=CBCalculated.Checked;
            Visible:=CBVisible.Checked;
            ReadOnly:=CBReadOnly.Checked;
	          CaptionStyle:=TCaptionStyle(CMBCaptionStyle.ItemIndex);
            PrivilegLevel:=EPL.Value;
            DisplayWidth:=EDisplayWidth.Value;
            Hint:=EHint.Text;

            if Result is TINIEntryStreamed then (Result as TINIEntryStreamed).ShowInGrid:=CBShowInGrid.Checked;

            Table:=Section;

            GroupName:=gName;

            try
	            if EFieldName.Text<>'' then FieldName:=EFieldName.Text;
  	          if EDisplayLabel.Text<>'' then DisplayLabel:=EDisplayLabel.Text;
    	        if EDefValue.Text<>'' then DefaultAsString:=EDefValue.Text;
      	      if ECName.Text<>'' then Result.Name:=ECName.Text;

              except
              	on E:Exception do begin
                 	if E is ECancelLongJob then raise;
                end;
            end;
          end;

          FDesigner.Modified;
        end;

				secOptionsDefEntry.AsInteger:=nE;
        INIEntryClassID:=nE;
      end;
    end;

    finally
			frmNewField.Free;
  end;
end;

procedure TfrmINIDatabase.GoTest(Node:TTreeNode;TestAll:Boolean);
var PrivateModes:TPrivateModes;

	procedure DoMain;
	var frmTestINIDatabase:TfrmTestINIDatabase;
			ParentSection,EditSection:TINICustomSection;
      EditGroup:string;
  begin
    EditSection:=nil;
  	ParentSection:=nil;

  	if TestAll or (Node=nil) then begin
      FINIDatabase.PrivateModes:=[pmPublic,pmGroupPrivate,pmUserPrivate];
    end else begin
      ParentSection:=GetSectionFromNode(Node);

      if (ParentSection=nil) and (TV.CurrentParam=listPO.ParamName) then begin
  	    FINIDatabase.PrivateModes:=[TPrivateMode(StrToInt(GetNodeID(Node)))]
      end;
    end;

    if Node<>nil then begin
	    EditSection:=GetSectionFromNode(Node);

  	  if TV.CurrentParam=listGroups.ParamName then
	      EditGroup:=GetNodeID(Node)
  	  else if TV.CurrentParam=listF.ParamName then
	      EditGroup:=GetNodeID(Node.Parent)
  	  else
    	  EditGroup:='';
    end;

    frmTestINIDatabase:=TfrmTestINIDatabase.Create(Application);

    try
    	secFont.SetFont(frmTestINIDatabase.Font);
    	secFont.SetFont(frmTestINIDatabase.pnlMain.Font);

      frmTestINIDatabase.GoTest(FINIDatabase,ParentSection,EditSection,EditGroup,dmTest,secTestingResizeable.AsBoolean);

      FDesigner.Modified;

      finally
        frmTestINIDatabase.Free;
    end;
  end;
  
begin
  PrivateModes:=FINIDatabase.PrivateModes;

  try
  	DoMain;

    finally
		  FINIDatabase.PrivateModes:=PrivateModes;
	end;
end;

procedure TfrmINIDatabase.DeleteTVNode(Node:TTreeNode;const ParamName:string);
begin
  if ParamName=listS.ParamName then
    DeleteSection(Node)
  else if ParamName=listF.ParamName then
    DeleteEntry(Node)
  else if ParamName=listGroups.ParamName then
    DeleteGroup(Node);

  PostRefreshLV;
end;

procedure TfrmINIDatabase.TVKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var r:TRect;
		p:TPoint;
begin
  FRefreshLVLevel:=1;

	if not TV.Editing then begin
    if Key=VK_F4 then begin
      Key:=0;

      SelectComponent;
    end;

    if Key=VK_F5 then begin
      Key:=0;

			if TV.Selected<>nil then TV.RefreshNode(TV.Selected);
    end;

    if TV.Selected<>nil then begin
      if (Shift=[]) or (Shift=[ssAlt]) then begin
        if Key=VK_INSERT then begin
          r:=TV.Selected.DisplayRect(True);
          p:=TV.ClientToScreen(r.TopLeft);

          if (TV.CurrentParam=listPO.ParamName) or ((TV.CurrentParam=listGroups.ParamName) and (ssAlt in Shift)) then begin
            if secOptionsPopup.AsBoolean then
              popMenuSections.Popup(p.X,p.Y)
            else
              AddNewSection(TV.KeyDownNode,secOptionsDefSection.AsInteger);
          end else if TV.CurrentParam=listGroups.ParamName then begin
            if secOptionsPopup.AsBoolean then
              popMenuEntries.Popup(p.X,p.Y)
            else
              AddNewEntry(TV.KeyDownNode,secOptionsDefEntry.AsInteger);
          end else if TV.CurrentParam=listS.ParamName then
            AddNewGroup(TV.KeyDownNode);

          Key:=0;
        end;

        if Key=VK_DELETE then begin
        	DeleteTVNode(TV.KeyDownNode,TV.CurrentParam);

          Key:=0;
        end;
      end;
    end;
  end;
end;

procedure TfrmINIDatabase.SelectComponent;

  procedure DoMain;
  var TVParam,cName:string;
      selC:TComponent;
      selS:TINICustomSection;
      Node:TTreeNode;
  begin
    TVParam:=TV.CurrentParam;

    Node:=TV.Selected;

    if Node<>nil then begin
      if TVParam=listGroups.ParamName then Node:=Node.Parent;

      cName:=AllTrim(GetNodeID(Node));

      if cName<>'' then begin
        selC:=FForm.FindComponent(cName);

        if selC=nil then begin
          selS:=GetINISection(AllTrim(GetNodeID(Node.Parent.Parent)));

          if selS<>nil then selC:=selS.FindField(cName);
        end;

        if selC is TINIEntrySubSection then selC:=(selC as TINIEntrySubSection).SubSection;

        if selC<>nil then begin
          FDesigner.SelectComponent(selC);
        end;
      end else if TVParam=listS.ParamName then begin
      	selS:=GetSectionFromNode(Node);

        if selS<>nil then FDesigner.SelectComponent(selS);
      end else if TVParam=listF.ParamName then begin
      	selC:=GetEntryFromNode(Node);

        if selC is TINIEntrySubSection then selC:=(selC as TINIEntrySubSection).SubSection;

        if selC<>nil then FDesigner.SelectComponent(selC);
      end;
    end;
  end;

begin
	try
  	DoMain;

    except
    	on E:Exception do begin
       	if E is ECancelLongJob then raise;
      end;
  end;
end;

procedure TfrmINIDatabase.InitSectionClasses;
var i:Integer;
		Description:string;

  function AddPopupItem(const mCaption:string;tValue:Integer):TMenuItem;
  begin
    Result:=TMenuItem.Create(nil);

    with Result do begin
      Caption:=LTrim(mCaption);
      OnClick:=OnMenuSectionsClick;
      Tag:=tValue;
    end;

    popMenuSections.Items.Add(Result);
  end;

begin
  listPO.Verbs.Add('-');
  listPO.Verbs.Add('New section');

  listGroups.Verbs.Add('-');
  listGroups.Verbs.Add('New section');

	for i:=0 to GetSectionClassesCount-1 do begin
  	Description:=GetSectionClassDescription(i);

    if i=2 then begin
	  	listPO.Verbs.Add(' -');
  		listGroups.Verbs.Add(' -');

	    AddPopupItem('-',i);
    end;

  	listPO.Verbs.Add(Format(' %s',[Description]));
  	listGroups.Verbs.Add(Format(' %s',[Description]));

    AddPopupItem(Description,i);
  end;
end;

procedure TfrmINIDatabase.InitEntryClasses;
var i:Integer;
		Description:string;

  function AddPopupItem(const mCaption:string;tValue:Integer):TMenuItem;
  begin
    Result:=TMenuItem.Create(nil);

    with Result do begin
      Caption:=LTrim(mCaption);
      OnClick:=OnMenuEntriesClick;
      Tag:=tValue;
    end;

    popMenuEntries.Items.Add(Result);
  end;

begin
  listS.Verbs.Add('New entry');
  listGroups.Verbs.Add('New entry');
  listF.Verbs.Add('-');
  listF.Verbs.Add('C&hange type to ...');

	for i:=0 to GetEntryClassesCount-1 do begin
  	Description:=GetEntryClassDescription(i);

  	listS.Verbs.Add(Format(' %s',[Description]));
  	listGroups.Verbs.Add(Format(' %s',[Description]));
  	listF.Verbs.Add(Format(' %s',[Description]));

    AddPopupItem(Description,i);
  end;
end;

procedure TfrmINIDatabase.OnMenuEntriesClick(Sender:TObject);
begin
	AddNewEntry(TV.KeyDownNode,(Sender as TMenuItem).Tag);
end;

procedure TfrmINIDatabase.OnMenuSectionsClick(Sender:TObject);
var nS:Integer;
begin
	nS:=(Sender as TMenuItem).Tag;

  AddNewSection(TV.KeyDownNode,nS);
end;

procedure TfrmINIDatabase.TVChange(Sender: TObject; Node: TTreeNode);
begin
	if (FInitializationLevel=0) and (Node<>nil) and (not Node.Deleting) then begin
  	if FRefreshLVLevel=0 then PostRefreshLV;
  end;
end;

procedure TfrmINIDatabase.PostRefreshLV;
begin
	if FRefreshLVLevel<32 then begin
    FRefreshLVLevel:=FRefreshLVLevel+1;

  	PostMessage(Self.Handle,WMU_REFRESHLV,0,0);
  end else begin
    RefreshLV(TV.Selected,True);

    FRefreshLVLevel:=0;
  end;
end;

procedure TfrmINIDatabase.WMRefreshLV(var Msg:TMessage);
begin
	PostRefreshLV;
end;

procedure TfrmINIDatabase.ShowLV(ShowIt:Boolean);
begin
	if ShowIt and not pnlRight.Visible then begin
  	pnlLeft.Align:=alLeft;
    pnlLeft.Width:=Min(pnlMain.ClientWidth-64,secMainLeftW.AsInteger);

    ResizeLine.Visible:=True;
    pnlRight.Visible:=True;

    ResizeLine.Left:=pnlLeft.Left+pnlLeft.Width+1;
    pnlRight.Left:=ResizeLine.Left+ResizeLine.Width+1;

    RefreshLV(TV.Selected,False);
  end else if not ShowIt and pnlRight.Visible then begin
  	secMainLeftW.AsInteger:=pnlLeft.Width;
    pnlLeft.Align:=alClient;

    ResizeLine.Visible:=False;
    pnlRight.Visible:=False;
  end;
end;

procedure TfrmINIDatabase.RefreshLV(Node:TTreeNode;Select:Boolean);
begin
  if (Node<>nil) and (FInitializationLevel=0) then begin
    if Select and (TV.CurrentParam<>listPO.ParamName) then SelectComponent;

    if pnlRight.Visible then begin
      if TV.CurrentParam=listPO.ParamName then
        ListPOSelected
      else if TV.CurrentParam=listS.ParamName then
        ListSSelected
      else if TV.CurrentParam=listGroups.ParamName then
        ListGroupsSelected
      else if TV.CurrentParam=listF.ParamName then
        ListFSelected;

      if LV.Items.Count>0 then with LV.Items[0] do begin
      	Selected:=True;
        Focused:=True;
      end;

      FLastSelectedParam:=TV.CurrentParam;
    end;

    if pnlPath.Visible then pnlPath.Caption:=#32+TV.Path;

    EnableClipboardCommands;

    FLastNode:=Node;
  end;
end;

procedure TfrmINIDatabase.SetLVColumns(Captions:array of string);
var LC:TListColumn;
		i:Integer;
begin
  LV.Items.Clear;
  LV.Columns.Clear;

  for i:=Low(Captions) to High(Captions) do begin
    LC:=LV.Columns.Add;

    LC.Caption:=Captions[i];
    LC.Width:=ColumnHeaderWidth;
  end;
end;

procedure TfrmINIDatabase.AddLVColumn(const Caption:string);
var LC:TListColumn;
begin
	LC:=LV.Columns.Add;

  LC.Caption:=Caption;
  LC.Width:=ColumnTextWidth;
end;

procedure TfrmINIDatabase.AddLVItem(const ComponentName,Caption:string;SubCaptions:array of string;ImageIndex:Integer);
var LI:TListItem;
		i:Integer;
begin
	LI:=LV.Items.Add;

  LI.Caption:=Caption;
  LI.ImageIndex:=ImageIndex;

  for i:=Low(SubCaptions) to High(SubCaptions) do
	  LI.SubItems.Add(SubCaptions[i]);

  for i:=High(SubCaptions)+1 to CLVComponentNameIndex-1 do
	  LI.SubItems.Add('');
    
  LI.SubItems.Add(ComponentName);
end;

procedure TfrmINIDatabase.ListPOSelected;
begin
	LVBeginUpdate;

 	if (FLastSelectedParam<>TV.CurrentParam) or (LV.Columns.Count=0) then begin
	  SetLVColumns(['Section','Type','File name','Component']);

    FLVGroups:=False;
  end;

  ListPOFillLV;
end;

procedure TfrmINIDatabase.ListPOFillLV;
begin
	LV.Items.Clear;

  try
    if TV.Selected<>nil then
	    DoGetSections(TV.Selected,AddSectionsToLV,nil)
    else if TV.Items.GetFirstNode<>nil then
	    DoGetSections(TV.Items.GetFirstNode,AddSectionsToLV,nil);

    finally
    	LVEndUpdate;
  end;
end;

procedure TfrmINIDatabase.AddSectionsToLV(C:TComponent;DistributedP,ExtraP:Pointer);
var Description:string;
		ii:Integer;
begin
	Description:=C.ClassName;

	ii:=GetSectionClassIndex(Description);

  if ii<>-1 then Description:=GetSectionClassDescription(ii);

	AddLVItem(C.Name,(C as TINICustomSection).SectionName,[Description,(C as TINICustomSection).FileName,C.Name],SectionImageIndex(C));
end;

procedure TfrmINIDatabase.ListSSelected;
begin
	LVBeginUpdate;

 	if FLastSelectedParam<>TV.CurrentParam then begin
  	SetLVColumns(['Group','Columns','Image index','Direction']);

    FLVGroups:=True;
  end;

  ListSFillLV;
end;

procedure TfrmINIDatabase.ListSFillLV;
begin
	LV.Items.Clear;

  try
    DoGetGroups(TV.Selected,AddGroupsToLV,nil);

    finally
    	LVEndUpdate;
  end;
end;

procedure TfrmINIDatabase.AddGroupsToLV(C:TComponent;DistributedP,ExtraP:Pointer);
begin
	AddLVItem((C as TINICustomSection).Name,(C as TINICustomSection).Group[Integer(ExtraP^)],
  	[IntToStr((C as TINICustomSection).ColumnsInGroup[Integer(ExtraP^)]),
     IntToStr((C as TINICustomSection).GroupImageIndex[Integer(ExtraP^)]),	
     CDirectionDescription[(C as TINICustomSection).DirectionInGroup[Integer(ExtraP^)]]],Integer(iiGroup));
end;

procedure TfrmINIDatabase.ListGroupsSelected;
begin
	LVBeginUpdate;

 	if FLastSelectedParam<>TV.CurrentParam then begin
  	SetLVColumns(['Display label','Type','Component']);

    FLVGroups:=False;
  end;

  ListGroupsFillLV;
end;

procedure TfrmINIDatabase.ListGroupsFillLV;
begin
	LV.Items.Clear;

  try
    DoGetFields(TV.Selected,AddFieldsToLV,nil);

    finally
    	LVEndUpdate;
  end;
end;

procedure TfrmINIDatabase.AddFieldsToLV(C:TComponent;DistributedP,ExtraP:Pointer);
var i,ii,ImageIndex:Integer;
		Description:string;
    Section:TINICustomSection;
begin
	i:=TFieldExtraInfo(ExtraP^).i;

	if TFieldExtraInfo(ExtraP^).IsSection then begin
    Section:=TFieldExtraInfo(ExtraP^).Section;
    
   	AddLVItem(Section.Name,Section.SectionName,['Sub-section',Section.Name],SectionImageIndex(Section));
  end else begin
  	ImageIndex:=Integer(iiField)+Integer(eiiString);
  	Description:=(C as TINICustomSection).Fields[i].ClassName;

  	ii:=GetEntryClassIndex(Description);

    if ii<>-1 then begin
      ImageIndex:=Integer(iiField)+GetEntryClassImageIndex(ii);
    	Description:=GetEntryClassDescription(ii);
    end;

    with (C as TINICustomSection).Fields[i] do
   		AddLVItem(Name,DisplayLabel,[Description,Name],ImageIndex);
  end;
end;

procedure TfrmINIDatabase.ListFSelected;
var INIE:TINIEntry;
begin
  INIE:=GetEntryFromNode(TV.Selected);

  if INIE<>nil then begin
		LVBeginUpdate;

    if (FLastSelectedParam<>TV.CurrentParam) or (FLVGroups<>(INIE is TINIEntrySubSection)) then begin
      FLVGroups:=INIE is TINIEntrySubSection;

      if FLVGroups then begin
        SetLVColumns(['Group','Columns','Image index','Direction']);
      end else begin
        SetLVColumns(['Property','Value']);
      end;
    end;

    ListFFillLV;
  end;
end;

procedure TfrmINIDatabase.ListFFillLV;
var INIE:TINIEntry;
		i:Integer;
begin
	LV.Items.Clear;

  try
    INIE:=GetEntryFromNode(TV.Selected);

    if INIE<>nil then begin
    	if INIE is TINIEntrySubSection then with INIE as TINIEntrySubSection do begin
      	if SubSection<>nil then begin
	      	for i:=0 to SubSection.GroupCount-1 do begin
			    	AddLVItem(SubSection.Name,SubSection.Group[i],
            	[IntToStr(SubSection.ColumnsInGroup[i]),IntToStr(SubSection.GroupImageIndex[i]),CDirectionDescription[SubSection.DirectionInGroup[i]]],Integer(iiGroup));
          end;
        end;
      end else begin
	    	AddLVItem(INIE.Name,'Component',[INIE.Name],CIIComponent);
    		AddLVItem(INIE.Name,'Class',[INIE.ClassName],CIIClass);
  	  	AddLVItem(INIE.Name,'Field name',[INIE.FieldName],CIIProperty);
	    	AddLVItem(INIE.Name,'Display label',[INIE.DisplayLabel],CIIProperty);
	    	AddLVItem(INIE.Name,'Display width',[IntToStr(INIE.DisplayWidth)],CIIProperty);
    		AddLVItem(INIE.Name,'Hint',[INIE.Hint],CIIProperty);
    		AddLVItem(INIE.Name,'Default',[INIE.DefaultAsString],CIIProperty);
      end;
    end;

    finally
    	LVEndUpdate;
  end;
end;

procedure TfrmINIDatabase.POPRunClick(Sender: TObject);
begin
	GoTest(TV.PopupNode,False);
end;

procedure TfrmINIDatabase.listGroupsEdited(Sender: TObject; EditedNode: TTreeNode; var S: string);
var INIS:TINICustomSection;
begin
	if AllTrim(S)<>'' then begin
  	INIS:=GetSectionFromNode(EditedNode);

    if INIS<>nil then begin
      INIS.RenameGroup(GetNodeID(EditedNode),S);

      TNodeObject(EditedNode.Data).StringContext:=S;

      FDesigner.Modified;
    end;
  end else begin
  	S:=EditedNode.Text;
  end;
end;

procedure TfrmINIDatabase.SetGroupAttributes(Section:TINICustomSection;const gName:string);
var frmNewGroup:TfrmNewGroup;
		Index:Integer;
begin
	if Section<>nil then begin
    frmNewGroup:=TfrmNewGroup.Create(Self);

    with frmNewGroup do try
      Index:=Section.GetGroupIndex(gName);

      if GetGroupData(gName,Section.ColumnsInGroup[Index],Section.GroupImageIndex[Index],Section.DirectionInGroup[Index],False,FINIDatabase.ImageList)=mrOK then begin
        Section.ColumnsInGroup[Index]:=EColumns.Value;
        Section.GroupImageIndex[Index]:=EImageIndex.Value;
        Section.DirectionInGroup[Index]:=TCreateDirection(CMBDirection.ItemIndex);
      end;

      finally
        frmNewGroup.Free;
    end;
  end;
end;

procedure TfrmINIDatabase.listGroupsExecuteVerb(Sender: TObject;PopupNode: TTreeNode; Verb: Integer);
var nEntry:TINIEntry;
		nNode:TTreeNode;
    fromS,newS:TINICustomSection;
    nS:Integer;
begin
	if Verb=0 then
  	TV.EditNode(TV.Selected)
  else if Verb=1 then
  	DeleteGroup(PopupNode)
  else if Verb=2 then
  	SetGroupAttributes(GetSectionFromNode(PopupNode),GetNodeID(PopupNode))
  else if Verb in [5..5+GetSectionClassesCount-1+Integer(GetSectionClassesCount>2)] then begin
    nS:=Verb-5;

    if nS>1 then nS:=nS-1;

  	fromS:=GetSectionFromNode(PopupNode);

    if fromS<>nil then begin
    	newS:=nil;
    	nEntry:=nil;

      try
        nEntry:=CreateEntrySubSection(fromS,GetNodeID(PopupNode));

        newS:=CreateNewSection(nS,fromS.PrivateMode,fromS);

        if newS<>nil then begin
          (nEntry as TINIEntrySubSection).SubSection:=newS;

          newS.PrivilegLevel:=fromS.PrivilegLevel;

          if NodeIsExpanded(PopupNode) then begin
            nNode:=TV.MakeNodeWithData(newS.SectionName,TNodeObject.CreateImageComponent(nEntry.Name,SectionImageIndex(newS),nEntry),PopupNode,True);

            nNode.Selected:=True;
          end else begin
            TV.RestoreNode(PopupNode);
          end;
        end;

        except
        	on Exception do begin
          	if (nEntry is TINIEntrySubSection) and ((nEntry as TINIEntrySubSection).SubSection=nil) then begin
            	if newS=nil then
	            	DestroyEntry(nEntry,True)
              else
	            	(nEntry as TINIEntrySubSection).SubSection:=newS;
            end;

          	raise;
          end;
      end;
    end;
  end else if Verb>5+GetSectionClassesCount+Integer(GetSectionClassesCount>2) then begin
  	AddNewEntry(PopupNode,Verb-(5+GetSectionClassesCount)-1-Integer(GetSectionClassesCount>2));
  end;
end;

procedure TfrmINIDatabase.AddNewEntry(Node:TTreeNode;EntryID:Integer);
var nEntry:TINIEntry;
		INIS:TINICustomSection;
    nNode:TTreeNode;
    ii:Integer;
begin
	INIS:=GetSectionFromNode(Node);

  if INIS<>nil then begin
    nEntry:=CreateNewEntry(EntryID,INIS,GetNodeID(Node));

    if nEntry<>nil then begin
      if NodeIsExpanded(Node) then begin
        ii:=Integer(iiField)+GetEntryClassImageIndexByName(GetEntryClass(EntryID).ClassName);

        nNode:=TV.MakeNodeWithData(nEntry.DisplayLabel,TNodeObject.CreateImageChildComponent(nEntry.Name,ii,False,nEntry),Node,False);

        nNode.Selected:=True;
      end else begin
        TV.RestoreNode(Node);
      end;
    end;
  end;
end;

procedure TfrmINIDatabase.listSEdited(Sender: TObject;EditedNode: TTreeNode; var S: string);
var INIS:TINICustomSection;
begin
	if AllTrim(S)<>'' then begin
  	INIS:=GetSectionFromNode(EditedNode);

    if INIS<>nil then begin
      INIS.SectionName:=S;

      FDesigner.SelectComponent(INIS);

      FDesigner.Modified;
    end;
  end else
  	S:=EditedNode.Text;
end;

procedure TfrmINIDatabase.listFExecuteVerb(Sender: TObject;PopupNode: TTreeNode; Verb: Integer);
var fD,nEntry:TINIEntry;
		INIS:TINICustomSection;
    Node:TTreeNode;
    EntryID:Integer;
    nName,nFieldName:string;
begin
	if Verb=0 then
  	TV.EditNode(TV.Selected)
  else if Verb=2 then
  	SaveSectionAsTemplate(GetSectionFromNode(PopupNode),True)
  else if (Verb=1) or (Verb=4) then begin
  	fD:=GetEntryFromNode(PopupNode);

    if fD<>nil then begin
    	if Verb=1 then begin
      	DeleteEntry(PopupNode);
      end else begin
      	if fD is TINIEntrySubSection then begin
        	INIS:=(fD as TINIEntrySubSection).SubSection;

          Node:=PopupNode;
        end else begin
        	INIS:=fD.Table as TINICustomSection;

          Node:=PopupNode.Parent.Parent;
        end;

        if INIS<>nil then AddNewGroupInSection(INIS,Node);
      end;
    end;
  end else if Verb>=7 then begin
  	fD:=GetEntryFromNode(PopupNode);

    if fD<>nil then begin
    	EntryID:=Verb-7;

      if (EntryID<>GetEntryClassIndex(fD.ClassName)) and not (fD is TINIEntrySubSection) and (fD.Owner=FForm) then begin
      	nFieldName:=fD.FieldName;
      	nName:=fD.Name;

      	nEntry:=CreateNewEntryByClass(GetEntryClass(EntryID),TINICustomSection(fD.Table),'',fD.GroupName);

        nEntry.Assign(fD);

        DestroyEntry(fD,True);

        nEntry.FieldName:=nFieldName;
        nEntry.Name:=nName;

        TV.Items.BeginUpdate;

        try
	        PopupNode.ImageIndex:=Integer(iiField)+GetEntryClassImageIndex(EntryID);
  	      PopupNode.SelectedIndex:=Integer(iiField)+GetEntryClassImageIndex(EntryID);

          finally
		        TV.Items.EndUpdate;
        end;

        RefreshLV(PopupNode,True);
      end;
  	end;
  end;
end;

procedure TfrmINIDatabase.DeleteGroup(Node:TTreeNode);
var INIS:TINICustomSection;
begin
	if Confirm(Format(ResStr(CResDeleteGroup),[Node.Text]),secMainConfirmDeleteGroup.AsBoolean) then begin
    INIS:=GetSectionFromNode(Node);

    if INIS<>nil then begin
    	if INIS.DeleteGroup(GetNodeID(Node)) then
      	TV.DeleteNode(Node)
      else
      	ShowMessage(Format(ResStr(CResCannotDeleteGroup),[GetNodeID(Node)]));
    end;
  end;
end;

procedure TfrmINIDatabase.DeleteEntry(Node:TTreeNode);
var INIE:TINIEntry;
begin
	if Node<>nil then begin
    if Confirm(Format(ResStr(CResDeleteEntry),[Node.Text]),secMainConfirmDeleteEntry.AsBoolean) then begin
      INIE:=GetEntryFromNode(Node);

      if (INIE<>nil) and DestroyEntry(INIE,False) then TV.DeleteNode(Node);
    end;
  end;
end;

function TfrmINIDatabase.DestroyEntry(Entry:TINIEntry;Always:Boolean):Boolean;
begin
	Result:=(Entry.Owner=FForm) or Always;

  if Result then begin
	  FDesigner.SelectComponent(FINIDatabase);

  	Entry.Free;
  end;
end;

function TfrmINIDatabase.GetEntryFromNode(Node:TTreeNode):TINIEntry;
var eName:string;
		P:Pointer;
begin
	eName:=GetNodeID(Node);

  if eName<>'' then
	 	Result:=GetINIEntry(eName)
  else begin
  	Result:=nil;

  	P:=TNodeObject(Node.Data).Data;

    if P<>nil then begin
    	try
      	Result:=TINIEntry(P);

      	except
        	Result:=nil;
      end;
    end;
  end;
end;

procedure TfrmINIDatabase.listFEdited(Sender: TObject;EditedNode: TTreeNode; var S: string);
var INIE:TINIEntry;
		INIS:TINICustomSection;
begin
	if AllTrim(S)<>'' then begin
  	INIE:=GetEntryFromNode(EditedNode);

    if INIE<>nil then begin
    	if INIE is TINIEntrySubSection then begin
        INIS:=(INIE as TINIEntrySubSection).SubSection;

        if INIS<>nil then begin
          INIS.SectionName:=S;

          FDesigner.SelectComponent(INIS);
        end;
      end else begin
        INIE.DisplayLabel:=S;

        TNodeObject(EditedNode.Data).StringContext:=INIE.Name;

        FDesigner.SelectComponent(INIE);
      end;
    end else begin
    	INIS:=GetSectionFromNode(EditedNode);

      if INIS<>nil then begin
      	INIS.SectionName:=S;

		    FDesigner.SelectComponent(INIS);
      end;
    end;

	  FDesigner.Modified;
  end else begin
  	S:=EditedNode.Text;
  end;
end;

procedure TfrmINIDatabase.listSExecuteVerb(Sender: TObject;PopupNode: TTreeNode; Verb: Integer);
var INIS:TINICustomSection;
begin
	if Verb=0 then
  	TV.EditNode(TV.Selected)
  else if Verb=1 then begin
  	DeleteSection(PopupNode);
  end else if Verb=2 then begin
  	SaveSectionAsTemplate(GetSectionFromNode(PopupNode),True);
  end else if Verb=4 then begin
  	AddNewGroup(PopupNode);
  end else if Verb>5 then begin
    INIS:=GetSectionFromNode(PopupNode);

    if INIS<>nil then begin
    	Verb:=Verb-6;
      
    	CreateNewEntry(Verb,INIS,INIS.Group[0]);
    end;
  end;
end;

function TfrmINIDatabase.SaveSectionAsTemplate(Section:TINICustomSection;Replace:Boolean):string;

  function DoMain(Section:TINICustomSection;Replace,Progress:Boolean):string;
  var INIE:TINIEntry;
      i,j:Integer;

  	function SaveSubSection(INIE:TINIEntry):string;
    var FSSFields,FSSGroups,FSSSections:string;
    begin
    	secSections.WriteSection;

      FSSFields:=secFields.Key;
      FSSGroups:=secGroups.Key;
      FSSSections:=secSections.Key;

      try
      	Result:=DoMain((INIE as TINIEntrySubSection).SubSection,False,False);
        
      	finally
        	secSections.Key:=FSSSections;
          secGroups.Key:=FSSGroups;
          secFields.Key:=FSSFields;
      end;
    end;

  	function GetKeyName:string;
    var Counter:Integer;
    		lResult:string;
    begin
      Result:=Section.SectionName;

      if Result='' then Result:=Section.Name;

      if secSections.KeyExists(Result) and not Replace then begin
      	lResult:=Result;

	      Counter:=1;

        repeat
        	Result:=Format('%s (%d)',[lResult,Counter]);

          Counter:=Counter+1;
        until not secSections.KeyExists(Result);
      end;
    end;

  begin
    if Section<>nil then begin
    	Result:=GetKeyName;

      secSections.DeleteKey(Result);
      secSections.AddKey(Result);

      secSectionsSectionName.AsString:=Section.SectionName;
      secSectionsType.AsInteger:=GetSectionClassIndex(Section.ClassName);
      secSectionsGroupType.AsInteger:=Integer(Section.GroupType);
      secSectionsRuntimeFile.AsBoolean:=Section.ParentDestination;
      secSectionsFileName.AsString:=Section.FileName;
      secSectionsDestination.AsString:=Section.Destination;
      secSectionsRows.AsInteger:=Section.Rows;

      for i:=0 to Section.GroupCount-1 do begin
        DoingLongJob(True,Progress,PositionInFor(i,Section.GroupCount-1));
        
        secGroups.AddKey(Section.Group[i]);

        secGroupsColumns.AsInteger:=Section.ColumnsInGroup[i];
        secGroupsDirection.AsInteger:=Integer(Section.DirectionInGroup[i]);

        for j:=0 to Section.FieldCount-1 do begin
          if Section.Fields[j] is TINIEntry then begin
            INIE:=Section.Fields[j] as TINIEntry;

            if INIE.Owner=Section.Owner then begin
              if AnsiCompareText(INIE.GroupName,Section.Group[i])=0 then begin
                if INIE is TINIEntrySubSection then begin
                  if (INIE as TINIEntrySubSection).SubSection<>nil then begin
                    secFields.AddKey(SaveSubSection(INIE));

                    secFieldsDisplayLabel.AsString:=secFields.Key;
                    secFieldsType.AsInteger:=GetEntryClassesCount;
                    secFieldsVisible.AsBoolean:=INIE.Visible;
                  end;
                end else begin
                  secFields.AddKey(INIE.FieldName);

                  secFieldsType.AsInteger:=GetEntryClassIndex(INIE.ClassName);
                  secFieldsDisplayLabel.AsString:=INIE.DisplayLabel;
                  secFieldsDisplayWidth.AsInteger:=INIE.DisplayWidth;
                  secFieldsVisible.AsBoolean:=INIE.Visible;
                  secFieldsCalculated.AsBoolean:=INIE.Calculated;
                  secFieldsDefaultValue.AsString:=INIE.DefaultAsString;
                  secFieldsCaptionStyle.AsInteger:=Integer(INIE.CaptionStyle);

                  if INIE is TINIEntryItems then with INIE as TINIEntryItems do begin
                    secFieldsItems1.List.Assign(Items);
                    secFieldsItems2.List.Assign(Descriptions);
                  end else if INIE is TINIEntrySaveList then with INIE as TINIEntrySaveList do begin
                    secFieldsItems1.List.Assign(StaticList);
                  end;
                end;

                secGroups.WriteSection;
              end;
            end;
          end;
        end;

        secFields.KeyIndex:=0;

        secSections.WriteSection;
      end;

      secGroups.KeyIndex:=0;
    end;
  end;

begin
	BeginLongJob(ResStr(CResSavingSectionAsTemplate));

  try
		Result:=DoMain(Section,Replace,True);

   	EndLongJob;
    
    except
    	on E:Exception do begin
      	if NotCancelException(E) then raise;
      end;
  end;
end;

procedure TfrmINIDatabase.DeleteSection(Node:TTreeNode);
var INIS:TINICustomSection;
begin
	if Confirm(Format(ResStr(CResDeleteSection),[Node.Text]),secMainConfirmDeleteSection.AsBoolean) then begin
    INIS:=GetSectionFromNode(Node);

    if (INIS<>nil) and DestroySection(INIS,False) then TV.DeleteNode(Node);
  end;
end;

function TfrmINIDatabase.DestroySection(Section:TINICustomSection;Always:Boolean):Boolean;
begin
	Result:=(Section.Owner=FForm) or Always;

  if Result then begin
	  FDesigner.SelectComponent(FINIDatabase);

  	Section.Free;
  end;
end;

procedure TfrmINIDatabase.AddNewGroup(Node:TTreeNode);
var INIS:TINICustomSection;
begin
  INIS:=GetSectionFromNode(Node);

  if INIS<>nil then AddNewGroupInSection(INIS,Node);
end;

procedure TfrmINIDatabase.AddNewGroupInSection(Section:TINICustomSection;Node:TTreeNode);
var frmNewGroup:TfrmNewGroup;
    nNode:TTreeNode;
begin
	if not Section.GroupExpandable then begin
  	ShowMessage(Format(ResStr(CResCannotAddGroup),[Section.SectionName]));
  
  	Exit;
  end;

  frmNewGroup:=TfrmNewGroup.Create(Self);

  with frmNewGroup do try
    if GetGroupData(INISec.DefaultGroupName,1,-1,cdTopToBottom,True,FINIDatabase.ImageList)=mrOK then begin
      if EGroupName.Text<>'' then begin
        Section.InsertGroup(EGroupName.Text,EColumns.Value,EImageIndex.Value,TCreateDirection(CMBDirection.ItemIndex),-1);

        if NodeIsExpanded(Node) then begin
          nNode:=TV.MakeNodeWithData(EGroupName.Text,TNodeObject.CreateImage(EGroupName.Text,Integer(iiGroup)),Node,False);

          nNode.Selected:=True;
        end else begin
          TV.RestoreNode(Node);
        end;
      end;
    end;

    finally
      frmNewGroup.Free;
  end;
end;

procedure TfrmINIDatabase.listPODragOver(Sender: TObject; DragNode, AcceptNode: TTreeNode; const DragParamName: string; var Accept: Boolean);
begin
  Accept:=DragParamName=listS.ParamName;
  Accept:=Accept or ((DragParamName=listF.ParamName) and (GetEntryFromNode(DragNode) is TINIEntrySubSection));
end;

procedure TfrmINIDatabase.listPODragDrop(Sender: TObject; DropNode, AcceptNode: TTreeNode; const DropParamName: string);
var INIS:TINICustomSection;
		MoveIt:Boolean;
begin
	INIS:=GetSectionFromNode(DropNode);

  if INIS<>nil then begin
  	MoveIt:=(INIS.PrivateMode<>TPrivateMode(StrToInt(GetNodeID(AcceptNode)))) or INIS.Son;
    
  	if INIS.Son then INIS.Parent:=FINIDatabase;

    INIS.PrivateMode:=TPrivateMode(StrToInt(GetNodeID(AcceptNode)));

    if MoveIt then begin
      TNodeObject(DropNode.Data).StringContext:=INIS.Name;

    	TV.MoveAsChild(DropNode,AcceptNode);
    end;
  end;
end;

procedure TfrmINIDatabase.listFDragOver(Sender: TObject; DragNode,AcceptNode: TTreeNode; const DragParamName: string; var Accept: Boolean);
begin
  Accept:=(GetNodeLevel(DragNode)=GetNodeLevel(AcceptNode)) and (AcceptNode<>DragNode);
end;

procedure TfrmINIDatabase.listFDragDrop(Sender: TObject; DropNode,AcceptNode: TTreeNode; const DropParamName: string);
var eD,eA:TINIEntry;
begin
  eD:=GetEntryFromNode(DropNode);
  eA:=GetEntryFromNode(AcceptNode);

  if (eD<>nil) and (eA<>nil) then begin
    eD.Table:=eA.Table;

    if eD.Index>eA.Index then
    	eD.Index:=eA.Index
    else
    	eD.Index:=eA.Index-1;

    eD.GroupName:=eA.GroupName;

    DropNode.MoveTo(AcceptNode,naInsert);

    TNodeObject(AcceptNode.Data).Dirty:=True;
    TNodeObject(DropNode.Data).StringContext:=eD.Name;
  end;
end;

procedure TfrmINIDatabase.listGroupsDragOver(Sender: TObject; DragNode,AcceptNode: TTreeNode; const DragParamName: string; var Accept: Boolean);
begin
	Accept:=DragParamName=listF.ParamName;
  Accept:=Accept or ((DragParamName=listGroups.ParamName) and NodeHasInformation(DragNode.Parent));
  Accept:=Accept or ((DragParamName=listS.ParamName) and (GetNodeID(AcceptNode.Parent)<>GetNodeID(DragNode)));
end;

procedure TfrmINIDatabase.listGroupsDragDrop(Sender: TObject; DropNode,AcceptNode: TTreeNode; const DropParamName: string);
var sA,toS,moveS:TINICustomSection;
		INIE:TINIEntry;
begin
	if DropParamName=listF.ParamName then begin
    sA:=GetSectionFromNode(AcceptNode);

    INIE:=GetEntryFromNode(DropNode);

    if (INIE<>nil) and ((INIE.Table<>sA) or (INIE.GroupName<>GetNodeID(AcceptNode))) then begin
      if sA<>nil then INIE.Table:=sA;

      INIE.GroupName:=GetNodeID(AcceptNode);

      TNodeObject(DropNode.Data).StringContext:=INIE.Name;

      TV.MoveAsChild(DropNode,AcceptNode);

      TV.FocusNode(AcceptNode);
    end;
  end else if DropParamName=listS.ParamName  then begin
  	moveS:=GetSectionFromNode(DropNode);
  	toS:=GetSectionFromNode(AcceptNode);

    if (toS<>nil) and (moveS<>nil) then begin
    	INIE:=nil;

      try
	  	 	INIE:=CreateEntrySubSection(toS,GetNodeID(AcceptNode));

		    (INIE as TINIEntrySubSection).SubSection:=moveS;

	      TV.MoveAsChild(DropNode,AcceptNode);

        except
        	on Exception do begin
          	if (INIE is TINIEntrySubSection) and ((INIE as TINIEntrySubSection).SubSection=nil) then begin
            	(INIE as TINIEntrySubSection).SubSection:=moveS;
            end;

						raise;              
          end;
      end;
    end;
  end else if DropParamName=listGroups.ParamName then begin
    sA:=GetSectionFromNode(DropNode);
  	toS:=GetSectionFromNode(AcceptNode);

    if (toS<>nil) and (sA<>nil) then begin
    	if toS=sA then begin
        if toS.ExchangeGroups(GetNodeID(DropNode),GetNodeID(AcceptNode)) then begin
	      	TV.MakeDirty(AcceptNode);
          
          DropNode.MoveTo(AcceptNode,naInsert);
        end;
      end else begin
      	TV.MakeDirty(AcceptNode);

      	case MoveGroupToSection(DropNode,AcceptNode.Parent,toS.GetGroupIndex(GetNodeID(AcceptNode))) of
	       	1:TV.MakeNodeWithData(GetNodeID(DropNode),TNodeObject.CreateImage(GetNodeID(DropNode),Integer(iiGroup)),AcceptNode.Parent,True);
  	     	2:DropNode.MoveTo(AcceptNode,naInsert);
        end;
      end;
    end;
  end;
end;

function TfrmINIDatabase.MoveGroupToSection(DropNode,AcceptNode:TTreeNode;Index:Integer):Integer;
var toS,fromS:TINICustomSection;
    GroupName:string;
    i,fc,GroupIndex:Integer;
begin
 	Result:=0;

	if DropNode.Parent=AcceptNode then Exit;

	fromS:=GetSectionFromNode(DropNode);
  toS:=GetSectionFromNode(AcceptNode);

  GroupName:=GetNodeID(DropNode);
  GroupIndex:=fromS.GetGroupIndex(GroupName);

  if (GroupIndex<>-1) and toS.GroupExpandable then begin
  	Result:=1;
    
    toS.InsertGroup(GroupName,fromS.ColumnsInGroup[GroupIndex],fromS.GroupImageIndex[GroupIndex],fromS.DirectionInGroup[GroupIndex],Index);

    i:=0;
    fc:=fromS.FieldCount-1;

    while i<=fc do begin
      if (fromS.Fields[i] is TINIEntry) and (fromS.Fields[i].Owner=FForm) and
      	 (CompareText((fromS.Fields[i] as TINIEntry).GroupName,GroupName)=0) then begin
        fromS.Fields[i].Table:=toS;

        fc:=fc-1;
      end else begin;
        i:=i+1;
      end;
    end;

    Result:=Result+Integer(fromS.DeleteGroup(GroupName));
  end;
end;

function TfrmINIDatabase.CreateGrabbedSection(SectionClass:TClassOfINISection;PM:TPrivateMode;const sName,fName,fDestination:string):TINICustomSection;
var lPossibleName,lSuffix:string;
		i:Integer;
begin
  Result:=FDesigner.CreateComponent(SectionClass,FForm,20,20,32,32) as TINICustomSection;

  if Result<>nil then with Result do begin
    Database:=FINIDatabase;
    SectionName:=sName;
    FileName:=fName;
    GroupType:=TGroupType(secMainGrabGroupType.AsInteger);
    GroupTitlePosition:=TGroupTitlePosition(secGrabbersGTP.AsInteger);
    Destination:=fDestination;
    ParentDestination:=False;
    PrivilegLevel:=FINIDatabase.UserPrivilegLevel;
    PrivateMode:=PM;
    Height:=-1;
    Rows:=secMainGrabRows.AsInteger;

    RenameGroup(Group[0],sName);

    ColumnsInGroup[0]:=secGrabbersColumns.AsInteger;
    DirectionInGroup[0]:=TCreateDirection(secGrabbersDirection.AsInteger);

    i:=1;

    lPossibleName:=OnlyAlnum(secMainDefPrefix.AsString);
    lSuffix:=MakeIdent(sName);

    while FForm.FindComponent(lPossibleName+lSuffix)<>nil do begin
	    lPossibleName:=Format('%s%d',[OnlyAlnum(secMainDefPrefix.AsString),i]);

      i:=i+1;
    end;

    try
	    Name:=lPossibleName+lSuffix;

      except
        on E:Exception do begin
         	if E is ECancelLongJob then raise;
        end;
    end;
  end;
end;

function TfrmINIDatabase.GrabStructureFromForm(PM:TPrivateMode;GrabFromForm:TForm):Integer;
var i,ECC:Integer;
    newS:TINICustomSection;

  procedure CreateEntriesFromControl(C:TWinControl;const gName:string);
  var i:Integer;

  	function TryByEntries(C:TWinControl):Boolean;
    var j:Integer;
				newE:TINIEntry;
        OK:Boolean;
    begin
    	newE:=nil;

      for j:=0 to ECC-1 do begin
        newE:=GetEntryClass(j).Create(FForm);

        if newE<>nil then begin
        	newE.Table:=newS;
          newE.ConnectedControl:=C;

          OK:=newE.ConnectedControl<>nil;

         	newE.Free;
          newE:=nil;

          if OK then begin
		        newE:=CreateNewEntryByClass(GetEntryClass(j),newS,C.Name,gName);

            with newE do begin
	            if secGrabbersForceDW.AsInteger>0 then DisplayWidth:=secGrabbersForceDW.AsInteger;

            	CaptionStyle:=TCaptionStyle(secGrabbersCStyle.AsInteger);
	          	ConnectedControl:=C;
            end;

          	Break;
          end;
        end;
      end;

      Result:=(newE<>nil) and (newE.ConnectedControl<>nil);
    end;

  begin
    TryByEntries(C);

    for i:=0 to C.ControlCount-1 do begin
      if C.Controls[i] is TWinControl then begin
      	newS.InsertGroup(C.Name,secGrabbersColumns.AsInteger,-1,TCreateDirection(secGrabbersDirection.AsInteger),-1);

      	CreateEntriesFromControl(C.Controls[i] as TWinControl,C.Name);
      end;
    end;
  end;

begin
	BeginLongJob(ResStr(CResGrabbingFormStructure));

	try
    newS:=CreateGrabbedSection(TINISection,PM,GrabFromForm.ClassName,FINIDatabase.FileName,FINIDatabase.Destination);

    ECC:=GetEntryClassesCount;

    for i:=0 to GrabFromForm.ControlCount-1 do begin
      DoingLongJob(False,True,PositionInFor(i,GrabFromForm.ControlCount-1));

      if GrabFromForm.Controls[i] is TWinControl then CreateEntriesFromControl(GrabFromForm.Controls[i] as TWinControl,GrabFromForm.ClassName);
    end;

    for i:=newS.GroupCount-1 downto 0 do begin
    	if newS.FieldsInGroup(newS.Group[i])=0 then newS.DeleteGroup(newS.Group[i]);
    end;

    EndLongJob;

    except
    	on E:Exception do begin
      	if NotCancelException(E) then raise;
      end;
  end;

  Result:=1;
end;

procedure TfrmINIDatabase.OpenProgressDialog(const Title:string;Open:Boolean);
begin
  if Open then begin
		lblProgress.Caption:=#32+Title+#32;
		lblProgress.Visible:=True;
		lblProgress.Repaint;

    ProgressBar.Position:=0;
    ProgressBar.Visible:=True;
    ProgressBar.Repaint;

    Application.ProcessMessages;
  end;
end;

procedure TfrmINIDatabase.CloseProgressDialog;
begin
  ProgressBar.Position:=ProgressBar.Max;

	lblProgress.Visible:=False;
  ProgressBar.Visible:=False;
end;

procedure TfrmINIDatabase.BeginLongJob(const Title:string);
begin
	if (FDoingLongJobValue=0) and (pnlMain.Enabled) then OpenProgressDialog(Title,secOptionsShowProgressDialog.AsBoolean);

 	pnlMain.Enabled:=False;
 	pnlButtons.Enabled:=False;

  FLongJobTitle:=Title;

  pnlBottom.Caption:=Format('%s%s',[#32+#32,'Click here to cancel ...']);
  pnlBottom.Repaint;

  FDoingLongJobValue:=1;
end;

procedure TfrmINIDatabase.EndLongJob;
begin
	CloseProgressDialog;

  FDoingLongJobValue:=0;

  pnlBottom.Caption:=#32;

 	pnlMain.Enabled:=True;
 	pnlButtons.Enabled:=True;
end;

procedure TfrmINIDatabase.DoingLongJob(AlwaysProcessMessages,Progress:Boolean;Position:Integer);
var Msg:TMsg;
begin
  if PeekMessage(Msg,pnlBottom.Handle,WM_LBUTTONDOWN,WM_LBUTTONDOWN+1,PM_NOREMOVE) then begin
  	if Confirm(Format('Cancel %s?',[#39+FLongJobTitle+#39]),True) then raise ECancelLongJob.Create('Canceled');
  end;

  if Progress then begin
    if secOptionsProcessMessages.AsBoolean or (FDoingLongJobValue=1) or AlwaysProcessMessages then begin
      Application.ProcessMessages;

      FDoingLongJobValue:=0;
    end;

    if Position>0 then
      ProgressBar.Position:=Position
    else
      AdvanceProgressBar(5);
  end;
end;

procedure TfrmINIDatabase.AdvanceProgressBar(Step:Integer);
begin
	if ProgressBar.Position=ProgressBar.Max then
  	ProgressBar.Position:=ProgressBar.Min+Step
  else if ProgressBar.Position+Step>=ProgressBar.Max then
  	ProgressBar.Position:=ProgressBar.Max
  else
  	ProgressBar.Position:=ProgressBar.Position+Step;

  ProgressBar.Repaint;
end;

function TfrmINIDatabase.GrabStructureFromFile(PM:TPrivateMode;FromRegistry:Boolean):Integer;
var INIStream:TINIStream;
    StreamName:string;
		EntryList:TStringList;

	function CreateEntry(Section:TINICustomSection;const sName,eName,Value:string):TINIEntry;

  	function SelectEntryClass:TClassOfINIEntry;
    var OK:Boolean;
    		EIndex:Integer;

    	procedure SmartMatch;
      begin
        OK:=True; try StrToFloat(Value); except on EConvertError do OK:=False; end;

        if OK then Result:=GetEntryClass(secGrabbersFloat.AsInteger);

        OK:=True; try StrToInt(Value); except on EConvertError do OK:=False; end;

        if OK then Result:=GetEntryClass(secGrabbersInteger.AsInteger);

        if Pos(Value,secStateBooleanValues.AsString)>0 then Result:=GetEntryClass(secGrabbersBoolean.AsInteger);
      end;
      
	  begin
      Result:=GetEntryClass(secGrabbersString.AsInteger);

	    if not secGrabbersForceString.AsBoolean then begin
      	if FromRegistry then begin
        	EIndex:=0;

        	case INIStream.EntryType(sName,eName) of
            etString:begin
            	Result:=GetEntryClass(secGrabbersString.AsInteger);

              SmartMatch;

              Exit;
            end;

          	etInteger:EIndex:=secGrabbersInteger.AsInteger;
	          etBoolean:EIndex:=secGrabbersBoolean.AsInteger;
            etFloat:EIndex:=secGrabbersFloat.AsInteger;
            etBinary:EIndex:=secGrabbersBinary.AsInteger;
          end;

          Result:=GetEntryClass(EIndex);
        end else begin
        	SmartMatch;
        end;
      end;
    end;

  begin
  	Result:=CreateNewEntryByClass(SelectEntryClass,Section,eName,Section.Group[0]);

    with Result do begin
    	if secGrabbersForceDW.AsInteger>0 then begin
        DisplayWidth:=secGrabbersForceDW.AsInteger;
      end else begin
        if Result is TINIEntryString then
          DisplayWidth:=iIf(Value<>'',Length(Value)+1,CDefDisplayWidth)
        else if Result is TINIEntryInteger then
          DisplayWidth:=Length(IntToStr(MAXLONGINT))+1
        else if Result is TINIEntryFloat then
          DisplayWidth:=16+1;
      end;

      CaptionStyle:=TCaptionStyle(secGrabbersCStyle.AsInteger);
    end;
  end;

	function CreateEntries(const SectionName:string;Section:TINICustomSection;FromRegistry:Boolean):Integer;
  var i:Integer;
  		Value:string;
  begin
  	Result:=0;

    if FromRegistry then begin
    	with CreateEntry(Section,SectionName,'Default','') do begin
      	FieldName:='';
        DisplayLabel:='Default';
      end;

      Result:=1;
    end;
    
  	EntryList.Clear;

  	INIStream.ReadSection(SectionName,EntryList);

  	for i:=0 to EntryList.Count-1 do begin
    	if EntryList[i]<>'' then begin
        try
          Value:=INIStream.ReadString(SectionName,EntryList[i],'');

          except
            on Exception do Value:='';
        end;

        CreateEntry(Section,SectionName,EntryList[i],Value);

        Result:=Result+1;
      end;
    end;
  end;

	function CreateRegistrySections(const RootSection:string;ParentSection:TINICustomSection;Progress:Boolean):Integer;
	var i,sResult:Integer;
      newES:TINIEntrySubSection;
  		newS:TINICustomSection;
      List:TStringList;
      FullSectionName:string;
  begin
  	Result:=0;

  	List:=TStringList.Create;

    try
      INIStream.ReadSections(RootSection,List);

      for i:=0 to List.Count-1 do begin
	      DoingLongJob(False,Progress,PositionInFor(i,List.Count-1));

        if List[i]<>'' then begin
        	FullSectionName:=MergePaths(RootSection,List[i]);

          newS:=CreateGrabbedSection(TINISection,PM,List[i],StreamName,INIStream.Description);
					newS.ParentDestination:=True;

          if secGrabbersNewGroupSS.AsBoolean then begin
            ParentSection.InsertGroup(List[i],secGrabbersColumns.AsInteger,-1,TCreateDirection(secGrabbersDirection.AsInteger),-1);
          end;

          newES:=CreateEntrySubSection(ParentSection,List[i]);
          newES.SubSection:=newS;

          sResult:=Result;

          try
            Result:=Result+CreateEntries(FullSectionName,newS,True);
            Result:=Result+CreateRegistrySections(FullSectionName,newS,False);

            finally
		          if Result=sResult then DestroySection(newS,False);
          end;
  			end;
      end;

      finally
      	List.Free;
    end;
  end;

	function CreateFileSections(const RootSection:string;ParentSection:TINICustomSection;Progress:Boolean):Integer;
	var i,sResult:Integer;
      newES:TINIEntrySubSection;
  		newS:TINICustomSection;
      List:TStringList;
      FullSectionName:string;
  begin
  	Result:=0;

  	List:=TStringList.Create;

    try
      INIStream.ReadSections(RootSection,List);

      for i:=0 to List.Count-1 do begin
	      DoingLongJob(False,Progress,PositionInFor(i,List.Count-1));

        if List[i]<>'' then begin
        	FullSectionName:=MergePaths(RootSection,List[i]);

          newS:=CreateGrabbedSection(TINISection,PM,List[i],StreamName,INIStream.Description);

          if ParentSection<>nil then begin
            newS.ParentDestination:=True;

            if secGrabbersNewGroupSS.AsBoolean then begin
              ParentSection.InsertGroup(List[i],secGrabbersColumns.AsInteger,-1,TCreateDirection(secGrabbersDirection.AsInteger),-1);
            end;

	          newES:=CreateEntrySubSection(ParentSection,List[i]);
  	        newES.SubSection:=newS;
          end;

          sResult:=Result;

          try
		        Result:=Result+CreateEntries(FullSectionName,newS,False);
            Result:=Result+CreateFileSections(FullSectionName,newS,False);

            finally
		          if Result=sResult then DestroySection(newS,False);
          end;
  			end;
      end;

      finally
      	List.Free;
    end;
  end;

	function DoMainRegistry:Integer;
  var frmSelectRegistryNode:TfrmSelectRegistryNode;
  		RootSection,RegistryPath:string;
      INIS:TINICustomSection;
  begin
  	Result:=0;

    INIStream:=nil;
    INIS:=nil;

    RootSection:='';
    RegistryPath:=strIf(secOptionsSaveRPath.AsBoolean,secMainRegistryPath.AsString,'');

    with FINIDatabase do begin
      frmSelectRegistryNode:=TfrmSelectRegistryNode.Create(Self);

      try
        StreamName:=frmSelectRegistryNode.GetNode(FINIDatabase.Names.Computer,RegistryPath);

        if StreamName<>'' then begin
          secMainRegistryPath.AsString:=StreamName;

          INIStream:=CreateStream(Names.Computer,LeftToCh(StreamName,'\'),CDefaultRegistryStream);

          RootSection:=RightFromCh(StreamName,'\');

          if ExtractFilePath(StreamName)<>'' then
	          INIS:=CreateGrabbedSection(TINISection,PM,ExtractFileName(StreamName),ExtractFilePath(StreamName),CDefaultRegistryStream)
          else
	          INIS:=CreateGrabbedSection(TINISection,PM,'',StreamName,CDefaultRegistryStream);


          CreateEntries(RootSection,INIS,True);
        end;

        finally
          frmSelectRegistryNode.Free;
      end;
    end;

    if INIStream<>nil then begin
			BeginLongJob(ResStr(CResGrabbingRegistryStructure));

    	try
	      Result:=CreateRegistrySections(RootSection,INIS,True);

        EndLongJob;

  	    INIStream.Free;

  	    except
        	on E:Exception do begin
  	  	    INIStream.Free;

		      	if NotCancelException(E) then raise;
          end;
	    end;
    end;
  end;

	function DoMainFile:Integer;
  begin
  	Result:=0;

    INIStream:=nil;

    with FINIDatabase do begin
      OD.FilterIndex:=secMainFilterIndex.AsInteger;
      OD.InitialDir:=secMainInitialDir.AsString;

      OD.Filter:='Configuration files (*.ini)|*.ini';

      secFilters.First;

      while not secFilters.EOL do begin
      	OD.Filter:=OD.Filter+'|'+secFilters.Key+'|'+secFiltersFilter.AsString;

      	secFilters.Next;
      end;

      OD.Filter:=OD.Filter+'|All files (*.*)|*.*';

      if OD.Execute then begin
        StreamName:=OD.FileName;

        secMainFilterIndex.AsInteger:=OD.FilterIndex;
        secMainInitialDir.AsString:=ExtractFilePath(OD.FileName);

        INIStream:=CreateStream(Names.Computer,StreamName,CDefaultFileStream);
      end;
    end;

    if INIStream<>nil then begin
			BeginLongJob(ResStr(CResGrabbingFileStructure));

    	try
	      Result:=CreateFileSections('',nil,True);

        EndLongJob;

  	    INIStream.Free;

  	    except
        	on E:Exception do begin
  	  	    INIStream.Free;

		      	if NotCancelException(E) then raise;
          end;
	    end;
    end;
  end;

begin
	EntryList:=TStringList.Create;

  try
  	if FromRegistry then
	  	Result:=DoMainRegistry
    else
    	Result:=DoMainFile;

    finally
    	EntryList.Free;
  end;
end;

function TfrmINIDatabase.GrabStructureFromComponent(PM:TPrivateMode;C:TObject):Integer;
var PClass:TClass;
		sName,eItem:string;
    PTD:PTypeData;

	function BinaryToString(Value:LongInt):string;
  begin
  	Result:='';

    while Value>0 do begin
    	Result:=Result+Chr(48+(Value mod 2));

      Value:=Value div 2;
    end;
  end;

  procedure CreateEntries(Section:TINICustomSection;TI:PTypeInfo;C:TObject;Progress:Boolean);
  var PL:TPropList;
  		TK:TTypeKind;
      nEntry:TINIEntry;
      i,j,pc:Integer;
      EClass:TClassOfINIEntry;
	    PTI:PTypeInfo;
	    PI:PPropInfo;

      procedure CreateSubClass;
      var gName:string;
		      newS:TINICustomSection;
          lC:TObject;
      begin
      	newS:=nil;

       	if secGrabbersNewGroupSS.AsBoolean then begin
          gName:=PL[i].Name;

        	Section.InsertGroup(gName,secGrabbersColumns.AsInteger,-1,TCreateDirection(secGrabbersDirection.AsInteger),-1);
        end else begin
        	gName:=Section.Group[0];
        end;

       	nEntry:=CreateEntrySubSection(Section,gName);

        try
	      	newS:=CreateGrabbedSection(TINISectionComponent,PM,PL[i].Name,FINIDatabase.FileName,FINIDatabase.Destination);

  	      if newS<>nil then (nEntry as TINIEntrySubSection).SubSection:=newS;

          except
          	on E:Exception do begin
              if (nEntry is TINIEntrySubSection) and ((nEntry as TINIEntrySubSection).SubSection=nil) then begin
                if newS=nil then
                  DestroyEntry(nEntry,True)
                else
                  (nEntry as TINIEntrySubSection).SubSection:=newS;

               	if E is ECancelLongJob then raise;
              end;
            end;
        end;

        try
          lC:=TObject(GetOrdProp(C,PI));

          except
            on Exception do lC:=nil;
        end;

      	if (newS<>nil) and (lC<>nil) and (lC.ClassType<>nil) then CreateEntries(newS,lC.ClassType.ClassInfo,lC,False);
      end;

  begin
  	if TI<>nil then begin
    	try
	      pc:=GetPropList(TI,tkProperties,@PL);

        except
        	on Exception do Exit;
      end;

      for i:=0 to pc-1 do begin
        PI:=PL[i];

        DoingLongJob(False,Progress,PositionInFor(i,pc-1));

  {$ifdef VER90}
        PTI:=PI.PropType;
  {$endif}
  {$ifndef VER90}
        PTI:=PI.PropType^;
  {$endif}

        TK:=PTI.Kind;

        EClass:=GetEntryClassByPropertyType(PI);

        if Assigned(EClass) then begin
          nEntry:=CreateNewEntryByClass(EClass,Section,PL[i].Name,Section.Group[0]);

          with nEntry do begin
            if secGrabbersForceDW.AsInteger>0 then DisplayWidth:=secGrabbersForceDW.AsInteger;

            CaptionStyle:=TCaptionStyle(secGrabbersCStyle.AsInteger);
          end;

          if nEntry is TINIEntryItems then with nEntry as TINIEntryItems do begin
            if TK in [tkEnumeration,tkSet] then begin
              PTD:=GetTypeData(PTI);

              if TK=tkEnumeration then begin
                PTD:=GetTypeData(PTD.BaseType{$ifndef VER90}^{$endif});
              end else begin
                PTI:=PTD.CompType{$ifndef VER90}^{$endif};
                PTD:=GetTypeData(PTI);
              end;

              for j:=PTD.MinValue to PTD.MaxValue do begin
                eItem:=GetEnumName(PTI,j);

                Items.Add(eItem);
                Descriptions.Add(eItem);
              end;

              try
                if nEntry is TINIEntryManyOfStrings then
                  nEntry.DefaultAsString:=BinaryToString(GetOrdProp(C,PI))
                else
                  nEntry.DefaultAsString:=Items[GetOrdProp(C,PI)];

                except
                  on EAccessViolation do begin
                  end;
              end;
            end;
          end else begin
            try
              if TK=tkInteger then
                nEntry.DefaultAsInteger:=GetOrdProp(C,PI)
              else if TK in [tkWChar,tkLString{$ifdef VER90},tkLWString{$endif}] then
                nEntry.DefaultAsString:=GetStrProp(C,PI)
              else if TK=tkFloat then
                nEntry.DefaultAsFloat:=GetFloatProp(C,PI);

              except
                on EAccessViolation do begin
                end;
            end;
          end;
        end else if TK=tkClass then begin
          CreateSubClass;
        end;
      end;
  	end;
  end;

begin
	Result:=0;

  PClass:=C.ClassType;

	if PClass.ClassInfo<>nil then begin
  	BeginLongJob(ResStr(CResGrabbingComponentStructure));
    
  	try
    	sName:=strIf(C is TComponent,(C as TComponent).Name,C.ClassName);

		  CreateEntries(CreateGrabbedSection(TINISectionComponent,PM,sName,FINIDatabase.FileName,FINIDatabase.Destination),PClass.ClassInfo,C,True);

  		Result:=1;

      EndLongJob;

      except
      	on E:Exception do begin
	      	if NotCancelException(E) then raise;
        end;
    end;
  end;
end;

function TfrmINIDatabase.GetFormComponent:TComponent;
var cName:string;
	  frmSelectComponent:TfrmSelectComponent;
begin
	Result:=nil;
  
	frmSelectComponent:=TfrmSelectComponent.Create(Self);

  try
  	cName:=frmSelectComponent.Go(FForm);

    if cName<>'' then begin
    	Result:=FForm.FindComponent(cName);

      if Result=nil then Result:=FForm;
    end;

  	finally
    	frmSelectComponent.Free;
  end;
end;

procedure TfrmINIDatabase.listPOExecuteVerb(Sender: TObject; PopupNode: TTreeNode; Verb: Integer);
var PM:TPrivateMode;
		DoRefresh:Boolean;
    C:TComponent;
begin
	if Verb in [1,2,3,4] then begin
  	DoRefresh:=False;
    
  	secGrabbers.KeyIndex:=Verb-1;

   	PM:=TPrivateMode(StrToInt(GetNodeID(TV.PopupNode)));

  	if Verb in [1,2] then begin
	  	DoRefresh:=(GrabStructureFromFile(PM,Verb<>1)>0) and (NodeIsExpanded(PopupNode) or (PopupNode.GetFirstChild=nil));
    end else if Verb=3 then begin
    	if FForm is TForm then
	      DoRefresh:=GrabStructureFromForm(PM,FForm as TForm)>0
      else
	      DoRefresh:=GrabStructureFromForm(PM,Self)>0;
    end else if Verb=4 then begin
    	C:=GetFormComponent;

      DoRefresh:=(C<>nil) and (GrabStructureFromComponent(PM,C)>0);
    end;

    if DoRefresh then
    	TV.RefreshNode(PopupNode)
    else
    	TV.MakeDirty(PopupNode);
  end else if Verb>6 then begin
  	Verb:=Verb-7;

    if Verb>1 then Verb:=Verb-1;

	  AddNewSection(PopupNode,Verb);
  end;
end;

procedure TfrmINIDatabase.AddNewSection(Node:TTreeNode;SectionID:Integer);
var newS:TINICustomSection;
		nNode:TTreeNode;
begin
 	newS:=CreateNewSection(SectionID,TPrivateMode(StrToInt(GetNodeID(Node))),nil);

  if newS<>nil then begin
  	if NodeIsExpanded(Node) then begin
			nNode:=TV.MakeNodeWithData(newS.SectionName,TNodeObject.CreateImageComponent(newS.Name,SectionImageIndex(newS),newS),Node,True);

  	  nNode.Selected:=True;
    end else begin
    	TV.RestoreNode(Node);
    end;
  end;
end;

procedure TfrmINIDatabase.ReadShortCuts;
begin
  if FForm<>nil then begin
	  INIDB.Names.Group:=FForm.Name;
  end;

  if FINIDatabase<>nil then begin
	  INIDB.Names.User:=FINIDatabase.Name;
  end;

  secShortCuts.ReadSection;
end;

procedure TfrmINIDatabase.OpenShortCuts(Open,All:Boolean);
begin
	if Open then begin
    BeginInitialization;

    try
      secShortCuts.First;

      while not secShortCuts.EOL do begin
        if secShortCutsOpenOnStart.AsBoolean or All then begin
          TV.GoToPath(secShortCutsShortCut.AsString);
        end;

        secShortCuts.Next;
      end;

      finally
        EndInitialization;
    end;
  end;
end;

procedure TfrmINIDatabase.WriteShortCuts;
begin
  secShortCuts.WriteSection;
end;

procedure TfrmINIDatabase.FormShow(Sender: TObject);
begin
	if FINIDatabase=nil then raise Exception.Create(ResStr(CResINIDatabaseMissing));

  DoBeforeShow;
end;

procedure TfrmINIDatabase.DoBeforeShow;
begin
	try
    FInitializationLevel:=0;

    ReadShortCuts;

    ShowLV(secOptionsShowLV.AsBoolean);

    TV.SetFocus;

	  ReadShortCuts;
    OpenShortCuts(secUserOptionsOpenShortcuts.AsBoolean,False);

//    RefreshLV(TV.Selected,False);

    EnableClipboardCommands;

    SetToolBarLocation;
    SetPathLocation;

    PostRefreshLV;

    except
      on E:Exception do begin
       	if E is ECancelLongJob then raise;
      end;
	end;
end;

function TfrmINIDatabase.GetLVSelections:TComponentList;
var i,lc:Integer;
		aComponent:TComponent;
begin
	if FSelectedComponents<>nil then FSelectedComponents.Free;

  FSelectedComponents:=TComponentList.Create;

  lc:=LV.Items.Count-1;

  for i:=0 to lc do begin
    if LV.Items[i].Selected then begin
    	aComponent:=FForm.FindComponent(LV.Items[i].SubItems[CLVComponentNameIndex]);

      if aComponent<>nil then FSelectedComponents.Add(aComponent);
    end;
  end;

  Result:=FSelectedComponents;
end;

procedure TfrmINIDatabase.SetLVSelections;
begin
	if TV.CurrentParam<>listF.ParamName then begin
		GetLVSelections;

  	if FSelectedComponents.Count>0 then FDesigner.SetSelections(FSelectedComponents);
  end;
end;

procedure TfrmINIDatabase.DeleteLVItems;
var nDeleted:Integer;

  function DoMain:Integer;
  var i,lc,iLastDeleted:Integer;
      C:TComponent;
      Deleted:Boolean;
  begin
  	Result:=0;

    iLastDeleted:=-1;

    LV.Items.BeginUpdate;

    try
      lc:=LV.Items.Count-1;

      for i:=lc downto 0 do begin
        DoingLongJob(False,True,PositionInFor(lc-i,lc));

        if LV.Items[i].Selected then begin
          Deleted:=False;

          C:=FForm.FindComponent(LV.Items[i].SubItems[CLVComponentNameIndex]);

          if FLastSelectedParam=listPO.ParamName then begin
            if C is TINICustomSection then begin
              DestroySection(C as TINICustomSection,False);

              Deleted:=True;
            end;
          end else if FLastSelectedParam=listS.ParamName then begin
            if C is TINICustomSection then Deleted:=(C as TINICustomSection).DeleteGroup(LV.Items[i].Caption);
          end else if FLastSelectedParam=listGroups.ParamName then begin
            if C is TINIEntry then begin
              DestroyEntry(C as TINIEntry,True);

              Deleted:=True;
            end;
          end;

          if Deleted then begin
          	iLastDeleted:=i;

          	LV.Items[i].Delete;

            Result:=Result+1;
          end;
        end;
      end;

      finally
        LV.Items.EndUpdate;
    end;

    if iLastDeleted<>-1 then begin
      if iLastDeleted>0 then begin
        LV.Items[iLastDeleted-1].Selected:=True;
        LV.Items[iLastDeleted-1].Focused:=True;
      end else if iLastDeleted<LV.Items.Count-1 then begin
        LV.Items[iLastDeleted+1].Selected:=True;
        LV.Items[iLastDeleted+1].Focused:=True;
      end;
    end;
  end;

begin
	nDeleted:=0;
  
	BeginLongJob(ResStr(CResDeletingListItems));

  try
  	nDeleted:=DoMain;

    EndLongJob;

    LV.SetFocus;

    except
    	on E:Exception do begin
      	if NotCancelException(E) then raise;
      end;
  end;

  if (nDeleted>0) and secOptionsRefreshTV.AsBoolean then begin
  	if TV.Selected<>nil then begin
    	if NodeIsExpanded(TV.Selected) then
      	TV.RefreshNode(TV.Selected)
      else
	    	TV.MakeDirty(TV.Selected);
    end;
  end;
end;

procedure TfrmINIDatabase.LVChange(Sender: TObject; Item: TListItem;Change: TItemChange);
begin
  EnableClipboardCommands;
end;

procedure TfrmINIDatabase.LVKeyPress(Sender: TObject; var Key: Char);
var INIS:TINICustomSection;
		i,Add:Integer;
begin
	if Key=#13 then begin
  	Key:=#0;

    SyncronizeTV;
  end;

	if FLVGroups and (LV.Selected<>nil) then begin
    INIS:=GetINISection(LV.Selected.SubItems[CLVComponentNameIndex]);

    if INIS<>nil then begin
    	Add:=iIf(Key='+',1,iIf(Key='-',-1,0));

      if Add<>0 then begin
        LV.Items.BeginUpdate;

        try
          for i:=0 to LV.Items.Count-1 do begin
          	if LV.Items[i].Selected then begin
              INIS.ColumnsInGroup[i]:=INIS.ColumnsInGroup[i]+Add;
              LV.Items[i].SubItems[0]:=IntToStr(INIS.ColumnsInGroup[i]);
            end;
          end;

          finally
            LV.Items.EndUpdate;
        end;
      end;
    end;
  end;
end;

procedure TfrmINIDatabase.listPOCustomizeList(Sender: TObject;Node:TTreeNode; List: TStringList);
begin
	List.AddObject('Public sections',TNodeObject.CreateImage('0',Integer(iiPublic)));
	List.AddObject('Group private sections',TNodeObject.CreateImage('1',Integer(iiGroupPrivate)));
	List.AddObject('User private sections',TNodeObject.CreateImage('2',Integer(iiUserPrivate)));
end;

procedure TfrmINIDatabase.LVKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	if Key=VK_DELETE then begin
  	if Shift=[] then begin
    	Key:=0;

      if Confirm(ResStr(CResDeleteSelectedItems),True) then DeleteLVItems;
    end;
  end;
  
	if FInitializationLevel=0 then SetLVSelections;
end;

procedure TfrmINIDatabase.LVDeleteClick(Sender: TObject);
begin
	DoLVDelete;
end;

procedure TfrmINIDatabase.DoLVDelete;
begin
	if Confirm(ResStr(CResDeleteSelectedItems),secOptionsDeleteItems.AsBoolean) then DeleteLVItems;
end;

procedure TfrmINIDatabase.POPRefreshClick(Sender: TObject);
begin
	TV.RefreshNode(TV.PopupNode);
end;

procedure TfrmINIDatabase.BBCloseClick(Sender: TObject);
begin
	Close;
end;

procedure TfrmINIDatabase.Notification(AComponent: TComponent; Operation: TOperation);
begin
	inherited Notification(AComponent,Operation);

  if Operation=opRemove then begin
  	if AComponent=FINIDatabase then begin
    	FClosing:=True;

    	Close;
    end;

    if AComponent=FForm then begin
    	FClosing:=True;

    	Close;
    end;
  end;
end;

procedure TfrmINIDatabase.OnGrabComponentStructureClick(Sender:TObject);
begin
	secGrabbers.KeyIndex:=2;
  
	if GrabStructureFromComponent(TPrivateMode(StrToInt(GetNodeID(TV.PopupNode))),FForm.FindComponent((Sender as TMenuItem).Caption))>0 then
		TV.RefreshNode(TV.PopupNode);
end;

procedure TfrmINIDatabase.OnGrabFormStructureClick(Sender:TObject);
var GrabForm:TForm;
begin
	try
		GrabForm:=Screen.Forms[(Sender as TMenuItem).Tag];

    except
    	on Exception do GrabForm:=nil;
  end;

  if GrabForm<>nil then begin
  	if GrabStructureFromForm(TPrivateMode(StrToInt(GetNodeID(TV.PopupNode))),GrabForm)>0 then
	  	TV.RefreshNode(TV.PopupNode);
  end;
end;

procedure TfrmINIDatabase.popMenuTVPopup(Sender: TObject);
var i:Integer;
		INIE:TINIEntry;

	procedure AddFormItems;
  var i:Integer;
  		MI,FMI:TMenuItem;
  begin
  	FMI:=popMenuTV.Items[8].Items[1];

  	for i:=0 to Screen.FormCount-1 do begin
    	MI:=TMenuItem.Create(FMI);

      with MI do begin
        Caption:=Screen.Forms[i].Caption;
        OnClick:=OnGrabFormStructureClick;
        Tag:=i;
      end;

      if FMI.IndexOf(MI)=-1 then FMI.Add(MI);
    end;
  end;

	procedure AddComponentItems;
  var List:TStringList;
  
    procedure DoMain;
    var i:Integer;
        MI,FMI:TMenuItem;
    begin
      FMI:=popMenuTV.Items[8].Items[2];

      for i:=0 to FForm.ComponentCount-1 do begin
      	if FForm.Components[i] is TPersistentClass then List.Add(FForm.Components[i].Name);
      end;
      
      for i:=0 to List.Count-1 do begin
        MI:=TMenuItem.Create(FMI);

        with MI do begin
          Caption:=List[i];
          OnClick:=OnGrabComponentStructureClick;
          Tag:=i;
        end;

        if FMI.IndexOf(MI)=-1 then FMI.Add(MI);
      end;
    end;

    begin
    	List:=TStringList.Create;

      try
      	DoMain;
        
      	finally
        	List.Free;
      end;
    end;

begin
  EnableClipboardCommands;

  POPExpandAll.Enabled:=(TV.PopupNode<>nil) and (TNodeObject(TV.PopupNode.Data).Child) and (TV.PopupNode.HasChildren);
  TVCopyName.Enabled:=(TV.PopupParam<>listPO.ParamName) and (TV.PopupParam<>listGroups.ParamName);

	if TV.PopupParam=listPO.ParamName then begin
  	try
	  	popMenuTV.Items[12].Items[1].Enabled:=StrToInt(GetNodeID(TV.PopupNode))=0;

      except
      	on E:Exception do begin
         	if E is ECancelLongJob then raise;
        end;
    end;
  end else if TV.PopupParam=listF.ParamName then begin
  	INIE:=GetEntryFromNode(TV.PopupNode);

    if (INIE=nil) or (INIE is TINIEntrySubSection) or (INIE.Owner<>FForm) then begin
    	for i:=0 to GetEntryClassesCount-1 do begin
      	popMenuTV.Items[18].Items[i].Enabled:=False;
      end;
    end;
  end;
end;

procedure TfrmINIDatabase.TVDeleteClick(Sender: TObject);
begin
	DoTVDelete;
end;

procedure TfrmINIDatabase.DoTVDelete;
begin
	if not TV.Editing then DeleteTVNode(TV.Selected,TV.CurrentParam);
end;

procedure TfrmINIDatabase.popMenuLVPopup(Sender: TObject);
begin
	EnableClipboardCommands;

  LVSep1.Visible:=FLVGroups;
  LVSep2.Visible:=FLVGroups;
  LVSetGroup.Visible:=FLVGroups;
  LVAddColumn.Visible:=FLVGroups;
  LVDeleteColumn.Visible:=FLVGroups;

  if FLVGroups then begin
	  LVSetGroup.Enabled:=LV.Selected<>nil;
    LVAddColumn.Enabled:=LV.Selected<>nil;
    LVDeleteColumn.Enabled:=LV.Selected<>nil;
  end;

  LVCopyName.Enabled:=(FLastSelectedParam<>listF.ParamName);
end;

procedure TfrmINIDatabase.EnableClipboardCommands;
var TVParam:string;
begin
  TVParam:=TV.CurrentParam;

	LVCopy.Enabled:=TVParam<>listF.ParamName;
	LVPaste.Enabled:=(TVParam<>listF.ParamName) and ClipboardComponents;
	LVDelete.Enabled:=(TVParam<>listF.ParamName) and (LV.Items.Count>0);

  TVCopy.Enabled:=TVParam<>listPO.ParamName;
  TVPaste.Enabled:=(TVParam<>listF.ParamName) and ClipboardComponents;
  TVDelete.Enabled:=GetNodeLevel(TV.PopupNode)>1;

  if TV.Focused then begin
  	SBCopy.Enabled:=TVCopy.Enabled;
  	SBPaste.Enabled:=TVPaste.Enabled;
  	SBDelete.Enabled:=TVDelete.Enabled;
  end else if LV.Focused then begin
  	SBCopy.Enabled:=LVCopy.Enabled;
  	SBPaste.Enabled:=LVPaste.Enabled;
  	SBDelete.Enabled:=LVDelete.Enabled;
  end else begin
  	SBCopy.Enabled:=False;
  	SBPaste.Enabled:=False;
  	SBDelete.Enabled:=False;
  end;

  POPSaveShortcut.Enabled:=TVParam<>listPO.ParamName;

  SBShortCuts.Enabled:=secShortCuts.KeyCount>0;
end;

procedure TfrmINIDatabase.LVCopyClick(Sender: TObject);
begin
	DoLVCopy;
end;

procedure TfrmINIDatabase.TVCopyClick(Sender: TObject);
begin
	DoTVCopy;
end;

procedure TfrmINIDatabase.LVBeginUpdate;
begin
	LV.Columns.BeginUpdate;
	LV.Items.BeginUpdate;
end;

procedure TfrmINIDatabase.LVEndUpdate;
begin
	LV.Items.EndUpdate;
	LV.Columns.EndUpdate;
end;

procedure TfrmINIDatabase.DoLVCopy;
begin
	CopyComponents(FForm,GetLVSelections);
end;

procedure TfrmINIDatabase.DoTVCopy;
var cList:TComponentList;
		INIF:TINIEntry;
    INIS:TINICustomSection;
    i:Integer;
    GroupName:string;
begin
	cList:=TComponentList.Create;

  try
    if TV.CurrentParam=listS.ParamName then
    	cList.Add(GetSectionFromNode(TV.PopupNode))
    else if TV.CurrentParam=listGroups.ParamName then begin
    	GroupName:=GetNodeID(TV.PopupNode);

    	INIS:=GetSectionFromNode(TV.PopupNode);

      if INIS<>nil then begin
      	for i:=0 to INIS.FieldCount-1 do begin
        	if (INIS.Fields[i] is TINIEntry) and (CompareText((INIS.Fields[i] as TINIEntry).GroupName,GroupName)=0) then
          	cList.Add(INIS.Fields[i]);
        end;
      end;
    end else if TV.CurrentParam=listF.ParamName then begin
    	INIF:=GetEntryFromNode(TV.PopupNode);

      if INIF<>nil then begin
      	if INIF is TINIEntrySubSection then
        	cList.Add((INIF as TINIEntrySubSection).SubSection)
        else
        	cList.Add(INIF);
      end;
    end;

    if (cList.Count>0) and (cList.Items[0]<>nil) then CopyComponents(FForm,cList);

    finally
    	cList.Free;
  end;
end;

procedure TfrmINIDatabase.LVPasteClick(Sender: TObject);
begin
	DoLVPaste;
end;

procedure TfrmINIDatabase.TVPasteClick(Sender: TObject);
begin
	DoTVPaste;
end;

procedure TfrmINIDatabase.DoTVPaste;
begin
	DoPaste;
end;

procedure TfrmINIDatabase.DoLVPaste;
begin
	DoPaste;
end;

procedure TfrmINIDatabase.DoPaste;
var i:Integer;
begin
	if ClipboardComponents then begin
    if FClpComponents<>nil then begin
      FClpComponents.Free;

      FClpComponents:=TComponentList.Create;
    end;

    if TV.CurrentParam=listPO.ParamName then begin
      FClpParent:=FINIDatabase;
      FClpExtraInfo.PM:=TPrivateMode(StrToInt(GetNodeID(TV.PopupNode)));
    end else begin
      FClpParent:=GetSectionFromNode(TV.PopupNode);

      if TV.CurrentParam=listGroups.ParamName then
        FClpExtraInfo.GroupName:=GetNodeID(TV.PopupNode)
      else
        FClpExtraInfo.GroupName:='';
    end;

    if FClpParent<>nil then begin
    	PasteComponents(FForm,FClpParent,FClpComponents);

      if (FClpComponents.Count=0) and (NodeIsExpanded(TV.PopupNode) or (TV.PopupNode.GetFirstChild=nil)) then
      	TV.RefreshNode(TV.PopupNode)
      else
      	TV.MakeDirty(TV.PopupNode);

      for i:=0 to FClpComponents.Count-1 do begin
        if FClpComponents[i] is TINICustomSection then
          DestroySection(FClpComponents[i] as TINICustomSection,True)
        else if FClpComponents[i] is TINIEntry then
          DestroyEntry(FClpComponents[i] as TINIEntry,True)
        else if FClpComponents[i]<>nil then
          FClpComponents[i].Free;
      end;
    end;
  end;
end;

procedure TfrmINIDatabase.LVAddColumnClick(Sender: TObject);
var PlusKey:Char;
begin
	PlusKey:='+';

	LVKeyPress(Sender,PlusKey);
end;

procedure TfrmINIDatabase.LVDeleteColumnClick(Sender: TObject);
var MinusKey:Char;
begin
	MinusKey:='-';

	LVKeyPress(Sender,MinusKey);
end;

procedure TfrmINIDatabase.listSDragOver(Sender: TObject; DragNode,
  AcceptNode: TTreeNode; const DragParamName: string; var Accept: Boolean);
begin
	Accept:=DragParamName=listGroups.ParamName;
  Accept:=Accept and NodeHasInformation(DragNode.Parent);
end;

procedure TfrmINIDatabase.listSDragDrop(Sender: TObject; DropNode,
  AcceptNode: TTreeNode; const DropParamName: string);
begin
	TV.MakeDirty(AcceptNode);
  
	case MoveGroupToSection(DropNode,AcceptNode,-1) of
    1:TV.MakeNodeWithData(GetNodeID(DropNode),TNodeObject.CreateImage(GetNodeID(DropNode),Integer(iiGroup)),AcceptNode,True);
  	2:TV.MoveAsChild(DropNode,AcceptNode);
  end;
end;

procedure TfrmINIDatabase.IamInitialized;
begin
	EndInitialization;
end;

procedure TfrmINIDatabase.BBOptionsClick(Sender: TObject);
begin
	EditOptions(secMain,nil,'Options','',540,440,True);
end;

procedure TfrmINIDatabase.EditOptions(Section,EditSection:TINICustomSection;const Title,EditGroup:string;W,H:Integer;ResetEnabled:Boolean);
begin
	BeginInitialization;

  try
    if FINIOptions=nil then FINIOptions:=TfrmINIOptions.Create(Self);

    FINIOptions.Caption:=Title;
    FINIOptions.ClientWidth:=W;
    FINIOptions.ClientHeight:=H;
    FINIOptions.BBReset.Enabled:=ResetEnabled;

    FINIOptions.GoOptions(INIDB,Section,EditSection,EditGroup,IamInitialized);

  	finally
			EndInitialization;
  end;
end;

procedure TfrmINIDatabase.secMainGroupNameChange(Sender: TINIField);
begin
	INISec.DefaultGroupName:=secMainGroupName.AsString;
end;

procedure TfrmINIDatabase.secOptionsAutoRenameChange(Sender: TINIField);
begin
	INISec.AutoRename:=secOptionsAutoRename.AsBoolean;
end;

procedure TfrmINIDatabase.secSectionsTypeInit(Sender: TINIField);
begin
	InitSectionTypes(Sender,-1);
end;

procedure TfrmINIDatabase.InitSectionTypes(Sender: TINIField;lCount:Integer);
var i:Integer;
		lDescription:string;
begin
	if lCount=-1 then lCount:=GetSectionClassesCount;

  lCount:=Min(lCount,GetSectionClassesCount);

	with Sender as TINIEntryOneOfStrings do begin
  	Clear;

    for i:=0 to lCount-1 do begin
      lDescription:=GetSectionClassDescription(i);

      Descriptions.Add(lDescription);
      Items.Add(lDescription);
    end;

    if GetSectionClassesCount>0 then DefaultValue:=Items[0];
  end;
end;

procedure TfrmINIDatabase.secFieldsTypeInit(Sender: TINIField);
begin
	InitEntryTypes(Sender);

  (Sender as TINIEntryOneOfStrings).AddItem('Sub-section','Sub-section');
end;

procedure TfrmINIDatabase.InitEntryTypes(Sender: TINIField);
var i:Integer;
		lDescription:string;
begin
	with Sender as TINIEntryOneOfStrings do begin
  	Clear;
    
    for i:=0 to GetEntryClassesCount-1 do begin
      lDescription:=GetEntryClassDescription(i);

      Descriptions.Add(lDescription);
      Items.Add(lDescription);
    end;

    if (GetEntryClassesCount>0) and (DefaultValue='') then DefaultValue:=Items[0];
  end;
end;

procedure TfrmINIDatabase.TVEnter(Sender: TObject);
begin
	if FInitializationLevel=0 then RefreshLV(TV.Selected,True);
end;

procedure TfrmINIDatabase.secOptionsCurrentPathChange(Sender: TINIField);
begin
	if FInitializationLevel=0 then pnlPath.Visible:=Sender.AsBoolean;
end;

procedure TfrmINIDatabase.secOptionsPathUpDownChange(Sender: TINIField);
begin
	if FInitializationLevel=0 then SetPathLocation;
end;

procedure TfrmINIDatabase.SetPathLocation;
begin
 	pnlPath.Visible:=secOptionsCurrentPath.AsBoolean;

  if secOptionsPathUpDown.AsInteger=0 then
    pnlPath.Align:=alTop
  else
    pnlPath.Align:=alBottom;
end;

procedure TfrmINIDatabase.FormResize(Sender: TObject);
begin
	if FInitializationLevel=0 then begin
    pnlLeft.Width:=Min(pnlMain.ClientWidth-64,pnlLeft.Width);
  	pnlButtons.Width:=Min(250,Self.ClientWidth);
  end;
end;

function TfrmINIDatabase.GetMinXSize:Integer;
begin
  if pnlTools.Visible and ([pnlTools.Align]*[alTop,alBottom]<>[]) then begin
	  Result:=pnlSB.Width;
  	Result:=Result+pnlToolRight.Width+((pnlTools.BorderWidth+pnlMain.BorderWidth) shl 1);
	  Result:=Result+Width-ClientWidth+4;

    Result:=Max(Result,240);
  end else begin
  	Result:=240;
  end;
end;

function TfrmINIDatabase.GetMinYSize:Integer;
begin
  if pnlTools.Visible and ([pnlTools.Align]*[alLeft,alRight]<>[]) then begin
	  Result:=Integer(pnlPath.Visible)*pnlPath.Height;
	  Result:=Result+pnlBottom.Height+pnlSB.Height+pnlToolRight.Height;
	  Result:=Result+((pnlTools.BorderWidth+pnlMain.BorderWidth) shl 1);
	  Result:=Result+Height-ClientHeight+4;

    Result:=Max(Result,164);
  end else begin
  	Result:=164;
  end;
end;

procedure TfrmINIDatabase.WMGetMinMaxInfo(var Msg:TWMGetMinMaxInfo);
begin
	inherited;

  if not (csLoading in ComponentState) then begin
    with Msg.MinMaxInfo^.ptMinTrackSize do begin
	    x:=GetMinXSize;
      y:=GetMinYSize;
    end;
  end;
end;

procedure TfrmINIDatabase.SBPopupClick(Sender: TObject);
var p:TPoint;
begin
	if TV.Selected<>nil then begin
    p:=SBPopup.ClientToScreen(Point(-1,SBPopup.Height-1));

    TV.PreparePopup(TV.Selected);

  	popMenuTV.Popup(p.X,p.Y);
  end;
end;

procedure TfrmINIDatabase.secUserOptionsShowToolBarChange(Sender: TINIField);
begin
	if FInitializationLevel=0 then pnlTools.Visible:=Sender.AsBoolean;
end;

procedure TfrmINIDatabase.SBPasteClick(Sender: TObject);
begin
	DoPaste;
end;

procedure TfrmINIDatabase.SBCopyClick(Sender: TObject);
begin
	if TV.Focused then
  	DoTVCopy
  else if LV.Focused then
  	DoLVCopy;
end;

procedure TfrmINIDatabase.SBDeleteClick(Sender: TObject);
begin
	if TV.Focused then
  	DoTVDelete
  else if LV.Focused then
  	DoLVDelete;
end;

procedure TfrmINIDatabase.SBSectionRunClick(Sender: TObject);
begin
	GoTest(TV.Selected,False);
end;

procedure TfrmINIDatabase.secSectionsDestinationInit(Sender: TINIField);
var i:Integer;
		Description:string;
begin
	secSectionsDestination.Clear;

	for i:=0 to GetStreamClassesCount-1 do begin
  	Description:=GetStreamClassDescription(i);

  	secSectionsDestination.Items.Add(Description);
  	secSectionsDestination.Descriptions.Add(Description);
  end;
end;

procedure TfrmINIDatabase.LVEnter(Sender: TObject);
begin
  EnableClipboardCommands;
end;

procedure TfrmINIDatabase.SBAboutClick(Sender: TObject);
begin
	GoAbout;
end;

procedure TfrmINIDatabase.GoAbout;
var frmAbout:TfrmAbout;
begin
	frmAbout:=TfrmAbout.Create(nil);

  try
  	frmAbout.ShowModal;

  	finally
    	frmAbout.Free;
  end;
end;       

procedure TfrmINIDatabase.TVInspectClick(Sender: TObject);
begin
	ShowInspector;
end;

procedure TfrmINIDatabase.SBInspectClick(Sender: TObject);
begin
	ShowInspector;
end;

procedure TfrmINIDatabase.secOptionsWarnDupFieldNameChange(
  Sender: TINIField);
begin
	INISec.WarnOnDuplicateFieldName:=secOptionsWarnDupFieldName.AsBoolean;
end;

procedure TfrmINIDatabase.BBHelpClick(Sender: TObject);
begin
	Application.HelpJump('ExploringDatabase');
end;

procedure TfrmINIDatabase.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
	CanClose:=pnlMain.Enabled;

  if CanClose and not FClosing then secMain.WriteSection;
end;

procedure TfrmINIDatabase.secOptionsShowLVChange(Sender: TINIField);
begin
	if FInitializationLevel=0 then ShowLV(Sender.AsBoolean);
end;

procedure TfrmINIDatabase.FormHide(Sender: TObject);
begin
	if not FClosing then WriteShortCuts;
  
	Application.HelpFile:=FSaveHLPFile;
end;

procedure TfrmINIDatabase.SaveAsShortCut(Node:TTreeNode);
begin
	if Node<>nil then begin
    secShortCuts.AddKey(Node.Text);
    
    secShortCutsShortCut.AsString:=TV.PathOfNode[Node];
    secShortCutsOpenOnStart.AsBoolean:=secUserOptionsOpenOnStart.AsBoolean;

    secShortCuts.WriteSection;

    EnableClipboardCommands;
  end;
end;

procedure TfrmINIDatabase.POPSaveShortCutClick(Sender: TObject);
begin
	SaveAsShortCut(TV.PopupNode);
end;

procedure TfrmINIDatabase.OnShortCutClick(Sender:TObject);
begin
	secShortCuts.KeyIndex:=(Sender as TMenuItem).Tag;

  if TV.GoToPath(secShortCutsShortCut.AsString) then begin
  	if secOptionsShowInspector.AsBoolean then
	  	ShowInspector
  	else
  		TV.SetFocus;
  end;

  RefreshLV(TV.Selected,True);
end;

procedure TfrmINIDatabase.OpenShortCutMenu;
var p:TPoint;
		i,kCount:Integer;
    MI:TMenuItem;
begin
	p:=SBShortCuts.ClientToScreen(Point(-1,SBShortCuts.Height-1));

  while popShortCuts.Items.Count>3 do popShortCuts.Items.Delete(0);

  kCount:=secShortCuts.KeyCount-1;

  for i:=0 to kCount do begin
  	MI:=TMenuItem.Create(popShortCuts.Items);

    with MI do begin
      Tag:=i;
      OnClick:=OnShortCutClick;

      Caption:=Format('%d %s',[kCount-i+1,secShortCuts.KeyByIndex[i]]);

      if kCount-i+1<=9 then Caption:='&'+Caption;
    end;

    popShortCuts.Items.Insert(0,MI);
  end;

  popShortCuts.Popup(p.X,p.Y);
end;

procedure TfrmINIDatabase.SBShortCutsClick(Sender: TObject);
begin
	OpenShortCutMenu;
end;

procedure TfrmINIDatabase.Edit1Click(Sender: TObject);
begin
	EditOptions(secShortCuts,nil,'Bookmarks','',500,240,False);

  EnableClipboardCommands;
end;

procedure TfrmINIDatabase.popShortCutsPopup(Sender: TObject);
begin
	POPShortCutsSeparator.Visible:=secShortCuts.KeyCount>0;
end;

function TfrmINIDatabase.CountToolBarVisibleButtons:Integer;
var i:Integer;
		SB:TSpeedButton;
begin
  Result:=0;

  for i:=0 to pnlSB.ControlCount-1 do begin
    SB:=pnlSB.Controls[i] as TSpeedButton;

    if secToolBar.FieldByName(OnlyAlnum(SB.Hint)).AsBoolean then Inc(Result);
  end;
end;

procedure TfrmINIDatabase.InitToolBar;
var i,vSB:Integer;
		SB:TSpeedButton;
begin
	vSB:=CountToolBarVisibleButtons;

  pnlSB.Visible:=vSB>0;

  if pnlSB.Visible then begin
  	for i:=0 to pnlSB.ControlCount-1 do begin
    	SB:=pnlSB.Controls[i] as TSpeedButton;

    	SB.Visible:=secToolBar.FieldByName(OnlyAlnum(SB.Hint)).AsBoolean;
    end;

  	if pnlTools.Align in [alTop,alBottom] then begin
    	pnlSB.Align:=alLeft;
		  pnlSB.Width:=28*vSB+2;
      pnlSB.Rows:=1;

      SetBounds(Left,Top,Width,Height);
    end else begin
    	pnlSB.Align:=alTop;
		  pnlSB.Height:=28*vSB+2;
      pnlSB.Rows:=8;
    end;
  end;
end;

procedure TfrmINIDatabase.secToolBarOpenpopupmenuChange(Sender: TINIField);
begin
	if FInitializationLevel=0 then begin
		InitToolBar;
    Height:=Max(Height,GetMinYSize);
	end;
end;

procedure TfrmINIDatabase.secToolBarShowAllClick(Sender: TObject);
var i:Integer;
begin
	for i:=0 to secToolBar.FieldCount-1 do begin
  	if secToolBar.Fields[i] is TINIEntryBoolean then secToolBar.Fields[i].AsBoolean:=True; 
  end;

  secToolBar.RefreshControls;
end;

procedure TfrmINIDatabase.SBRunClick(Sender: TObject);
begin
	GoTest(TV.Selected,True);
end;

procedure TfrmINIDatabase.POPExpandAllClick(Sender: TObject);
begin
	TV.ExpandAll(TV.PopupNode);
end;

procedure TfrmINIDatabase.LVSetGroupClick(Sender: TObject);
var i,Columns,ImageIndex,Index:Integer;
		Direction:TCreateDirection;
		INIS:TINICustomSection;
    frmNewGroup:TfrmNewGroup;
    gName:string;

	function LVSelectedNo:Integer;
  var i:Integer;
  begin
  	Result:=0;

    for i:=0 to LV.Items.Count-1 do if LV.Items[i].Selected then Inc(Result);
  end;

begin
	if FLVGroups and (LV.Selected<>nil) then begin
    INIS:=GetINISection(LV.Selected.SubItems[CLVComponentNameIndex]);

    if INIS<>nil then begin
      frmNewGroup:=TfrmNewGroup.Create(Self);

      with frmNewGroup do try
      	Index:=LV.Selected.Index;

        gName:=strIf(LVSelectedNo>1,'',INIS.Group[Index]);

        if GetGroupData(gName,INIS.ColumnsInGroup[Index],INIS.GroupImageIndex[Index],INIS.DirectionInGroup[Index],False,FINIDatabase.ImageList)=mrOK then begin
        	Columns:=EColumns.Value;
        	ImageIndex:=EImageIndex.Value;
        	Direction:=TCreateDirection(CMBDirection.ItemIndex);

          LV.Items.BeginUpdate;

          try
            for i:=0 to LV.Items.Count-1 do begin
              if LV.Items[i].Selected then begin
                INIS.ColumnsInGroup[i]:=Columns;
                INIS.GroupImageIndex[i]:=ImageIndex;
                INIS.DirectionInGroup[i]:=Direction;

                with LV.Items[i] do begin
                	SubItems[0]:=IntToStr(INIS.ColumnsInGroup[i]);
	                SubItems[1]:=CDirectionDescription[INIS.DirectionInGroup[i]];
                end;
              end;
            end;

            finally
              LV.Items.EndUpdate;
          end;
        end;

        finally
        	frmNewGroup.Free;
      end;
    end;
  end;
end;

procedure TfrmINIDatabase.LVInspectClick(Sender: TObject);
begin
	ShowInspector;
end;

procedure TfrmINIDatabase.FormDeactivate(Sender: TObject);
begin
	Application.HelpFile:=FSaveHLPFile;
end;

procedure TfrmINIDatabase.FormActivate(Sender: TObject);
begin
	FSaveHLPFile:=Application.HelpFile;
  
	Application.HelpFile:=CHLPFile;

  FLastSelectedParam:='';
  FLastNode:=nil;
end;

procedure TfrmINIDatabase.TVKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	if (FRefreshLVLevel>0) and (TV.Selected<>FLastNode) then PostRefreshLV;
end;

procedure TfrmINIDatabase.TVMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
	FRefreshLVLevel:=0;
end;

procedure TfrmINIDatabase.Openall1Click(Sender: TObject);
begin
	OpenShortCuts(True,True);
end;

procedure TfrmINIDatabase.secOptionsDefEntryInit(Sender: TINIField);
begin
	InitEntryTypes(Sender);
end;

procedure TfrmINIDatabase.secFieldsTypeChange(Sender: TINIField);
begin
	if ssEdit in secFields.State then begin
    if secFieldsType.AsInteger=GetEntryClassesCount then begin
      secFieldsDisplayLabel.Caption:='Sub-section name';
      secFieldsDisplayLabel.EnableControl(False);
    end else begin
      secFieldsDisplayLabel.Caption:='Display label';
      secFieldsDisplayLabel.EnableControl(True);
    end;
  end;
end;

procedure TfrmINIDatabase.secFieldsBeforeEdit(Sender: TObject);
begin
	secFieldsTypeChange(nil);
end;

procedure TfrmINIDatabase.LVClick(Sender: TObject);
begin
	if FInitializationLevel=0 then SetLVSelections;
end;

procedure TfrmINIDatabase.secOptionsShowResizingChange(Sender: TINIField);
begin
	ResizeLine.ShowResizing:=Sender.AsBoolean;
end;

procedure TfrmINIDatabase.secMainLeftWBeforeWrite(Sender: TINIField);
begin
	if pnlRight.Visible then secMainLeftW.AsInteger:=pnlLeft.Width;
end;

procedure TfrmINIDatabase.LVDblClick(Sender: TObject);
begin
	SyncronizeTV;
end;

procedure TfrmINIDatabase.SyncronizeTV;
begin
	if (TV.Selected<>nil) and (LV.Selected<>nil) then begin
    if (FLastSelectedParam=listF.ParamName) and (not FLVGroups) and (LV.Selected.Index=0) then
    	ShowInspector
    else if TV.Selected.HasChildren then begin
    	TV.OpenChildNode(LV.Selected.Caption);

      RefreshLV(TV.Selected,False);
    end;
  end;
end;

procedure TfrmINIDatabase.TVClick(Sender: TObject);
begin
	if (FInitializationLevel=0) and (TV.Selected<>FLastNode) then RefreshLV(TV.Selected,True);
end;

procedure TfrmINIDatabase.secGrabbersChange(Sender: TObject);
var FileOrRegistry:Boolean;
begin
	if ssEdit in secGrabbers.State then begin
  	FileOrRegistry:=secGrabbers.KeyIndex<=1;

  	secGrabbersForceString.EnableControl(FileOrRegistry);
    secGrabbersInteger.EnableControl(FileOrRegistry);
    secGrabbersString.EnableControl(FileOrRegistry);
    secGrabbersBoolean.EnableControl(FileOrRegistry);
    secGrabbersFloat.EnableControl(FileOrRegistry);
    secGrabbersBinary.EnableControl(FileOrRegistry);
  end;
end;

procedure TfrmINIDatabase.secOptionsAlwaysRebuildTreeStructureAfterExpandChange(
  Sender: TINIField);
begin
	TV.AlwaysRebuild:=Sender.AsBoolean;
end;

procedure TfrmINIDatabase.secOptionsToolBarLocationChange(
  Sender: TINIField);
begin
	if FInitializationLevel=0 then SetToolBarLocation;
end;

procedure TfrmINIDatabase.SetToolBarLocation;
begin
	pnlTools.Visible:=secUserOptionsShowToolBar.AsBoolean;
  pnlTools.Align:=TAlign(secOptionsToolBarLocation.AsInteger+1);

  if pnlTools.Align in [alLeft,alRight] then begin
  	pnlTools.Width:=38;
    pnlSB.Rows:=8;
  	pnlToolRight.Align:=alBottom;
  end else begin
  	pnlTools.Height:=38;
    pnlSB.Rows:=1;
  	pnlToolRight.Align:=alRight;
  end;

  InitToolBar;

	SetBounds(Left,Top,Max(Width,GetMinXSize),Max(Height,GetMinYSize));
end;

procedure TfrmINIDatabase.TBRightClick(Sender: TObject);
begin
	secOptionsToolBarLocation.AsInteger:=(Sender as TMenuItem).Tag-1;
end;

procedure TfrmINIDatabase.Hide1Click(Sender: TObject);
begin
	secUserOptionsShowToolBar.AsBoolean:=False;
end;

procedure TfrmINIDatabase.LVCopyNameClick(Sender: TObject);
begin
	if LV.Selected<>nil then Clipboard.AsText:=LV.Selected.SubItems[CLVComponentNameIndex];
end;

procedure TfrmINIDatabase.TVCopyNameClick(Sender: TObject);
var INIE:TINIEntry;
begin
	if TV.PopupNode<>nil then begin
  	if TV.PopupParam=listF.ParamName then begin
    	INIE:=GetEntryFromNode(TV.PopupNode);

      if INIE<>nil then begin
      	if (INIE is TINIEntrySubSection) and ((INIE as TINIEntrySubSection).SubSection<>nil) then
			  	Clipboard.AsText:=(INIE as TINIEntrySubSection).SubSection.Name
        else
			  	Clipboard.AsText:=INIE.Name;
      end;
    end else
	  	Clipboard.AsText:=GetNodeID(TV.PopupNode);
  end;
end;

procedure TfrmINIDatabase.popToolBarPopup(Sender: TObject);
begin
	TBTop.Enabled:=pnlTools.Align<>alTop;
	TBBottom.Enabled:=pnlTools.Align<>alBottom;
	TBLeft.Enabled:=pnlTools.Align<>alLeft;
	TBRight.Enabled:=pnlTools.Align<>alRight;
end;

procedure TfrmINIDatabase.Hide2Click(Sender: TObject);
begin
	secOptionsCurrentPath.AsBoolean:=False;
end;

procedure TfrmINIDatabase.popPathPopup(Sender: TObject);
begin
	PTHTop.Enabled:=pnlPath.Align<>alTop;
	PTHbottom.Enabled:=pnlPath.Align<>alBottom;
end;

procedure TfrmINIDatabase.PTHBottomClick(Sender: TObject);
begin
	secOptionsPathUpDown.AsInteger:=(Sender as TMenuItem).Tag;
end;

procedure TfrmINIDatabase.Customize1Click(Sender: TObject);
begin
	EditOptions(secMain,secUserOptions,'Options','Tool-bar',540,440,True);
end;

procedure TfrmINIDatabase.INIDBAfterRead(Sender: TObject);
begin
	INISec.AutoRename:=secOptionsAutoRename.AsBoolean;
end;

procedure TfrmINIDatabase.LVSelectAllClick(Sender: TObject);
var i:Integer;
begin
	for i:=0 to LV.Items.Count-1 do LV.Items[i].Selected:=True;
end;

procedure TfrmINIDatabase.Invertselection1Click(Sender: TObject);
var i:Integer;
begin
	for i:=0 to LV.Items.Count-1 do LV.Items[i].Selected:=not LV.Items[i].Selected;
end;

procedure TfrmINIDatabase.secGrabbersIntegerInit(Sender: TINIField);
begin
	InitEntryTypes(Sender);

  (Sender as TINIEntry).Reset;
end;

procedure TfrmINIDatabase.TVCopyCreationCodeClick(Sender: TObject);
begin
	ShowMessage('Sorry, not yet implemented !');
end;

initialization
	frmINIDatabase:=nil;

finalization
	if frmINIDatabase<>nil then begin
		frmINIDatabase.Free;

    frmINIDatabase:=nil;
	end;

end.
