{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: Registration unit
//******************************************************
//******************************************************

unit INIReg;

interface

uses Classes,Dialogs,Forms,DsgnIntf,ChkGroup,INISec,INIEnt,INIEntEx,INIDsgn,INISecEx,
		 INIFile,INIUtil,INITree,FSaver{$ifndef VER90}{$else},DateEdit{$endif};


procedure Register;

implementation

procedure Register;
begin
	RegisterComponents('INIDb',[TINIDatabase]);

  RegisterNoIcon([TINITable]);
  RegisterNoIcon([TINIField]);

	RegisterINIStream(CDefaultFileStream,TINIStreamFile);
	RegisterINIStream(CDefaultRegistryStream,TINIStreamRegistry);

	RegisterINISection('Single',TINISection);
  RegisterINISection('Multi',TINIMultiSection);

  RegisterINIEntry('String',eiiString,TINIEntryString);
  RegisterINIEntry('Float',eiiFloat,TINIEntryFloat);
 	RegisterINIEntry('Integer',eiiInteger,TINIEntryInteger);
  RegisterINIEntry('Boolean',eiiBoolean,TINIEntryBoolean);
  RegisterINIEntry('Binary',eiiBinary,TINIEntryBinary);
  RegisterINIEntry('Color',eiiColor,TINIEntryColor);
  RegisterINIEntry('Save list',eiiCombo,TINIEntrySaveList);
	RegisterINIEntry('One of strings',eiiCombo,TINIEntryOneOfStrings);
  RegisterINIEntry('Many of strings',eiiCheckGroup,TINIEntryManyOfStrings);
	RegisterINIEntry('Shortcut',eiiString,TINIEntryShortCut);
  RegisterINIEntry('Paint box',eiiPaintBox,TINIEntryPaintBox);
	RegisterINIEntry('Separator',eiiSeparator,TINIEntrySeparator);
  RegisterINIEntry('Next column',eiiNextColumn,TINIEntryNextColumn);
  RegisterINIEntry('Button',eiiButton,TINIEntryButton);

  INIEntEx.Register;
  INISecEx.Register;

  RegisterClasses([TINIEntrySubSection]);

  RegisterPropertyEditor(TypeInfo(TNames), TINIDatabase, '', TNamesProperty);
  RegisterPropertyEditor(TypeInfo(TDirs), TINIDatabase, '', TDirsProperty);
  RegisterPropertyEditor(TypeInfo(TGlyphs), TINIDatabase, '', TGlyphsProperty);
  RegisterPropertyEditor(TypeInfo(TGlyphDescriptor), nil, '', TGlyphDescriptorProperty);
  RegisterPropertyEditor(TypeInfo(string),TINIEntry, 'GroupName', TGroupNameProperty);
  RegisterPropertyEditor(TypeInfo(TDestination),TINIDatabase,'Destination',TDestinationProperty);
  RegisterPropertyEditor(TypeInfo(TDestination),TINITable,'Destination',TDestinationProperty);

  RegisterComponentEditor(TINIDatabase,TINIDatabaseEditor);

	RegisterComponents('INIDb+', [TFormSaver,TPaintTextBox,TAutoAlignPanel,TLineForResizing,TDBTreeView,TSimpleListDistributor,TListViewExtended]);
	RegisterComponents('Samples', [TCheckGroup{$ifndef VER90}{$else},TDateEdit{$endif}]);
end;

end.